/****************************************************************************
 * Ralink Tech Inc.
 * 4F, No. 2 Technology 5th Rd.
 * Science-based Industrial Park
 * Hsin-chu, Taiwan, R.O.C.
 * (c) Copyright 2002, Ralink Technology, Inc.
 *
 * All rights reserved. Ralink's source code is an unpublished work and the
 * use of a copyright notice does not imply otherwise. This source code
 * contains confidential trade secret material of Ralink Tech. Any attemp
 * or participation in deciphering, decoding, reverse engineering or in any
 * way altering the source code is stricitly prohibited, unless the prior
 * written consent of Ralink Technology, Inc. is obtained.
 ****************************************************************************/

#include "rt_config.h"

/*
    ==========================================================================
    Description:
        Pre-build a BEACON frame in the shared memory
    ==========================================================================
*/
ULONG MakeBssBeacon(
    IN PRTMP_ADAPTER pAd) 
{
    UCHAR         SsidIe = IE_SSID, DsIe = IE_DS_PARM, SuppIe = IE_SUPP_RATES, 
                  DsLen = 1, TimIe = IE_TIM, TimLen = 4, // DtimCount=0, DtimPeriod=1,
                  BitmapControl = 0, VirtualBitmap = 0;
    MACHDR        BcnHdr;
    USHORT        CapabilityInfo;
    LARGE_INTEGER FakeTimestamp;
    ULONG         FrameLen;
    PTXD_STRUC	  pTxD = (PTXD_STRUC)pAd->BeaconRing.va_addr;
    CHAR         *pBeaconFrame = (CHAR *)pAd->BeaconRing.va_data_addr;
	UCHAR			RSNIe = IE_WPA_RSN_IE;

    // compose IBSS beacon frame
    MgtMacHeaderInit(pAd, &BcnHdr, SUBTYPE_BEACON, &pAd->PortCfg.Broadcast);
    CapabilityInfo = CAP_GENERATE(1, 0, 0, 0, (pAd->PortCfg.WepStatus != Ndis802_11EncryptionDisabled) );
	if(pAd->PortCfg.AuthMode>=Ndis802_11AuthModeWPA)
	{
		//CapabilityInfo |= 0x10;

		MakeOutgoingFrame(pBeaconFrame,                    &FrameLen,
							MAC_HDR_LEN,                     &BcnHdr, 
							TIMESTAMP_LEN,                   &FakeTimestamp,
							2,                               &pAd->PortCfg.BeaconPeriod,
							2,                               &CapabilityInfo,
							1,                               &SsidIe, 
							1,                               &pAd->PortCfg.SsidLen, 
							pAd->PortCfg.SsidLen,						pAd->PortCfg.Ssid,
							1,                               &SuppIe, 
							1,                               &pAd->PortCfg.SupportedRatesLen,
							pAd->PortCfg.SupportedRatesLen,  pAd->PortCfg.SupportedRates, 
							1,                               &DsIe, 
							1,                               &DsLen, 
							1,                               &pAd->PortCfg.Channel,
							1,                                &RSNIe,
							1,                               &pAd->PortCfg.RSNIE_Len,
							pAd->PortCfg.RSNIE_Len,        pAd->PortCfg.RSN_IE,        
							1,                               &TimIe, 
							1,                               &TimLen, 
							1,                               &pAd->Mlme.DtimCount,
							1,                               &pAd->Mlme.DtimPeriod,
							1,                               &BitmapControl,
							1,                               &VirtualBitmap,
							END_OF_ARGS);

		pAd->Mlme.TimIELocationInBeacon = MAC_HDR_LEN + TIMESTAMP_LEN + 6 + pAd->PortCfg.SsidLen +
			2 + pAd->PortCfg.SupportedRatesLen + 3 + 2 + 22;
	}  
	else
	{
    MakeOutgoingFrame(pBeaconFrame,                    &FrameLen,
                      MAC_HDR_LEN,                     &BcnHdr, 
                      TIMESTAMP_LEN,                   &FakeTimestamp,
                      2,                               &pAd->PortCfg.BeaconPeriod,
                      2,                               &CapabilityInfo,
                      1,                               &SsidIe, 
                      1,                               &pAd->PortCfg.SsidLen, 
                      pAd->PortCfg.SsidLen,             pAd->PortCfg.Ssid,
                      1,                               &SuppIe, 
                      1,                               &pAd->PortCfg.SupportedRatesLen,
                      pAd->PortCfg.SupportedRatesLen,  pAd->PortCfg.SupportedRates, 
                      1,                               &DsIe, 
                      1,                               &DsLen, 
                      1,                               &pAd->PortCfg.Channel,
                      1,                               &TimIe, 
                      1,                               &TimLen, 
                      1,                               &pAd->Mlme.DtimCount,
                      1,                               &pAd->Mlme.DtimPeriod,
                      1,                               &BitmapControl,
                      1,                               &VirtualBitmap,
                      END_OF_ARGS);

    pAd->Mlme.TimIELocationInBeacon = MAC_HDR_LEN + TIMESTAMP_LEN + 6 + pAd->PortCfg.SsidLen +
                                      2 + pAd->PortCfg.SupportedRatesLen + 3;
	}
    RTMPWriteTxDescriptor(pTxD, FALSE, FALSE, TRUE, SHORT_RETRY, IFS_BACKOFF, RATE_2, 4, FrameLen, pAd->PortCfg.TxPreamble);
    return FrameLen;
}


