/*
 ***************************************************************************
 * Ralink Tech Inc.
 * 4F, No. 2 Technology 5th Rd.
 * Science-based Industrial Park
 * Hsin-chu, Taiwan, R.O.C.
 *
 * (c) Copyright 2002, Ralink Technology, Inc.
 *
 * All rights reserved. Ralink's source code is an unpublished work and the
 * use of a copyright notice does not imply otherwise. This source code
 * contains confidential trade secret material of Ralink Tech. Any attemp
 * or participation in deciphering, decoding, reverse engineering or in any
 * way altering the source code is stricitly prohibited, unless the prior
 * written consent of Ralink Technology, Inc. is obtained.
 ***************************************************************************/

#ifndef _OID_H_
#define _OID_H_

#include <linux/wireless.h>

#define OID_GEN_MACHINE_NAME               0x0001021A

//
// IEEE 802.11 OIDs
//
// Ralink defined OIDs
#if WIRELESS_EXT <= 11
#ifndef SIOCDEVPRIVATE
#define SIOCDEVPRIVATE                              0x8BE0
#endif
#define SIOCIWFIRSTPRIV								SIOCDEVPRIVATE
#endif

#define RT_PRIV_IOCTL								SIOCIWFIRSTPRIV + 0x01
#define RTPRIV_IOCTL_SET							SIOCIWFIRSTPRIV + 0x02

#define OID_GET_SET_TOGGLE							0x8000

// IOCTL SubCmd definition
#define RTLINUX_GET_OID_802_11_BSSID_LIST                      8001	// Get Access Points list
#define RTLINUX_SET_OID_802_11_BSSID_LIST_SCAN                 8002	// Start Site Survey
#define RTLINUX_GET_MEDIA_CONNECT_STATUS                       8003
#define RTLINUX_SET_OID_802_11_BSSID                           8004 
#define RTLINUX_GET_OID_802_11_SSID                            8005
#define RTLINUX_GET_OID_802_11_BSSID                           8006
#define RTLINUX_GET_OID_802_11_CONFIGURATION                   8007
#define RTLINUX_GET_RT_OID_802_11_QUERY_LINK_STATUS            8008
#define RTLINUX_GET_OID_802_11_RSSI                            8009
#define RTLINUX_GET_OID_802_11_INFRASTRUCTURE_MODE             8010
#define RTLINUX_SET_OID_802_11_INFRASTRUCTURE_MODE             8011
#define RTLINUX_GET_OID_802_11_TX_ANTENNA_SELECTED             8012
#define RTLINUX_SET_OID_802_11_TX_ANTENNA_SELECTED             8013
#define RTLINUX_GET_OID_802_11_RX_ANTENNA_SELECTED             8014
#define RTLINUX_SET_OID_802_11_RX_ANTENNA_SELECTED             8015
#define RTLINUX_GET_OID_802_11_DESIRED_RATES                   8016
#define RTLINUX_SET_OID_802_11_DESIRED_RATES                   8017
#define RTLINUX_GET_OID_802_11_QUERY_PREAMBLE                  8018
#define RTLINUX_SET_OID_802_11_SET_PREAMBLE                    8019
#define RTLINUX_GET_OID_802_11_TX_POWER_LEVEL                  8020
#define RTLINUX_SET_OID_802_11_TX_POWER_LEVEL                  8021
#define RTLINUX_GET_OID_802_11_RTS_THRESHOLD                   8022
#define RTLINUX_SET_OID_802_11_RTS_THRESHOLD                   8023 
#define RTLINUX_GET_OID_802_11_FRAGMENTATION_THRESHOLD         8024
#define RTLINUX_SET_OID_802_11_FRAGMENTATION_THRESHOLD         8025
#define RTLINUX_GET_OID_802_11_AUTHENTICATION_MODE             8026
#define RTLINUX_SET_OID_802_11_AUTHENTICATION_MODE             8027
#define RTLINUX_GET_OID_802_11_WEP_STATUS                      8028
#define RTLINUX_SET_OID_802_11_WEP_STATUS                      8029
#define RTLINUX_SET_OID_802_11_REMOVE_WEP                      8030
#define RTLINUX_SET_OID_802_11_ADD_WEP                         8031
#define RTLINUX_SET_OID_802_11_CONFIGURATION                   8032
#define RTLINUX_GET_OID_802_11_POWER_MODE                      8033
#define RTLINUX_SET_OID_802_11_POWER_MODE                      8034
#define RTLINUX_SET_OID_802_11_SSID                            8035
#define RTLINUX_GET_OID_802_11_STATISTICS                      8036
#define RTLINUX_GET_OID_GEN_RCV_OK                             8037
#define RTLINUX_GET_OID_GEN_RCV_NO_BUFFER                      8038
#define RTLINUX_SET_RT_OID_802_11_RESET_COUNTERS               8039
#define RTLINUX_GET_OID_802_3_CURRENT_ADDRESS                  8040
#define RTLINUX_GET_VERSION_INFO                               8041

#define RTLINUX_GET_RT_OID_802_11_QUERY_HARDWARE_REGISTER      8042
#define RTLINUX_SET_RT_OID_802_11_SET_HARDWARE_REGISTER        8043

#define RTLINUX_RT_OID_802_11_SET_COUNTRY_REGION			   8046
#define RTLINUX_GET_OID_802_11_QUERY_EVENT_TABLE			   8047
#define RTLINUX_GET_OID_802_11_QUERY_MAC_TABLE				   8048
#define RTLINUX_SET_OID_802_11_FILTER_ENTRY					   8049

#define RT_OID_802_11_WDS                           0x0219
#define RT_OID_802_11_RADIUS_DATA                   0x8220
#define RT_OID_802_11_WPA_REKEY                     0x0221
#define RTLINUX_SET_OID_802_11_TEST_MODE		   			   8051
#define OID_802_11_ADD_KEY	                            0x811C
//
// IEEE 802.11 structures and definitions
//
typedef  UCHAR   NDIS_802_11_MAC_ADDRESS[6];

typedef enum _NDIS_802_11_NETWORK_TYPE {
   Ndis802_11FH, 
   Ndis802_11DS, 
   Ndis802_11NetworkTypeMax
} NDIS_802_11_NETWORK_TYPE, *PNDIS_802_11_NETWORK_TYPE;

typedef struct _NDIS_802_11_NETWORK_TYPE_LIST {
   ULONG                       NumberOfItems;
   NDIS_802_11_NETWORK_TYPE    NetworkType [1];
} NDIS_802_11_NETWORK_TYPE_LIST, *PNDIS_802_11_NETWORK_TYPE_LIST;

typedef enum _NDIS_802_11_POWER_MODE {
   Ndis802_11PowerModeCAM,
   Ndis802_11PowerModeMAX_PSP,
   Ndis802_11PowerModeFast_PSP,
   Ndis802_11PowerModeMax
} NDIS_802_11_POWER_MODE, *PNDIS_802_11_POWER_MODE;

typedef ULONG   NDIS_802_11_TX_POWER_LEVEL; // in milliwatts

//
// Received Signal Strength Indication
//
typedef LONG    NDIS_802_11_RSSI;           // in dBm

typedef struct _NDIS_802_11_CONFIGURATION_FH {
   ULONG           Length;            // Length of structure
   ULONG           HopPattern;        // As defined by 802.11, MSB set 
   ULONG           HopSet;            // to one if non-802.11
   ULONG           DwellTime;         // units are Kusec
} NDIS_802_11_CONFIGURATION_FH, *PNDIS_802_11_CONFIGURATION_FH;

typedef struct _NDIS_802_11_CONFIGURATION {
   ULONG                           Length;             // Length of structure
   ULONG                           BeaconPeriod;       // units are Kusec
   ULONG                           ATIMWindow;         // units are Kusec
   ULONG                           DSConfig;           // Frequency, units are kHz
   NDIS_802_11_CONFIGURATION_FH    FHConfig;
} NDIS_802_11_CONFIGURATION, *PNDIS_802_11_CONFIGURATION;

typedef struct _NDIS_802_11_STATISTICS {
   ULONG           Length;             // Length of structure
   LARGE_INTEGER   TransmittedFragmentCount;
   LARGE_INTEGER   MulticastTransmittedFrameCount;
   LARGE_INTEGER   FailedCount;
   LARGE_INTEGER   RetryCount;
   LARGE_INTEGER   MultipleRetryCount;
   LARGE_INTEGER   RTSSuccessCount;
   LARGE_INTEGER   RTSFailureCount;
   LARGE_INTEGER   ACKFailureCount;
   LARGE_INTEGER   FrameDuplicateCount;
   LARGE_INTEGER   ReceivedFragmentCount;
   LARGE_INTEGER   MulticastReceivedFrameCount;
   LARGE_INTEGER   FCSErrorCount;
} NDIS_802_11_STATISTICS, *PNDIS_802_11_STATISTICS;

typedef  ULONG  NDIS_802_11_KEY_INDEX;

typedef struct _NDIS_802_11_WEP {
   ULONG     Length;        // Length of this structure
   ULONG     KeyIndex;      // 0 is the per-client key, 1-N are the global keys
   ULONG     KeyLength;     // length of key in bytes
   UCHAR     KeyMaterial[1];// variable length depending on above field
} NDIS_802_11_WEP, *PNDIS_802_11_WEP;

typedef enum _NDIS_802_11_NETWORK_INFRASTRUCTURE {
   Ndis802_11IBSS,
   Ndis802_11Infrastructure,
   Ndis802_11AutoUnknown,
   Ndis802_11InfrastructureMax     // Not a real value, defined as upper bound
} NDIS_802_11_NETWORK_INFRASTRUCTURE, *PNDIS_802_11_NETWORK_INFRASTRUCTURE;

// Key mapping keys require a BSSID
typedef ULONGLONG   NDIS_802_11_KEY_RSC;
typedef struct _NDIS_802_11_KEY{
    ULONG           Length;             // Length of this structure
    ULONG           KeyIndex;           
    ULONG           KeyLength;          // length of key in bytes
    NDIS_802_11_MAC_ADDRESS BSSID;
    NDIS_802_11_KEY_RSC KeyRSC;
    UCHAR           KeyMaterial[1];     // variable length depending on above field
} NDIS_802_11_KEY, *PNDIS_802_11_KEY;

typedef enum _NDIS_802_11_AUTHENTICATION_MODE {
   Ndis802_11AuthModeOpen,
   Ndis802_11AuthModeShared,
   Ndis802_11AuthModeAutoSwitch,
	Ndis802_11AuthModeWPA,
	Ndis802_11AuthModeWPAPSK,
	Ndis802_11AuthModeWPANone,
   Ndis802_11AuthModeMax           // Not a real mode, defined as upper bound
} NDIS_802_11_AUTHENTICATION_MODE, *PNDIS_802_11_AUTHENTICATION_MODE;

typedef  UCHAR   NDIS_802_11_RATES[8];  // Set of 8 data rates


typedef struct _NDIS_802_11_SSID {
   ULONG   SsidLength;         // length of SSID field below, in bytes; this can be zero.
   UCHAR   Ssid[32];           // SSID information field
} NDIS_802_11_SSID, *PNDIS_802_11_SSID;

typedef struct _NDIS_WLAN_BSSID {
   ULONG                               Length;     // Length of this structure
   NDIS_802_11_MAC_ADDRESS             MacAddress; // BSSID
   UCHAR                               Reserved[2];
   NDIS_802_11_SSID                    Ssid;       // SSID
   ULONG                               Privacy;    // WEP encryption requirement
   NDIS_802_11_RSSI                    Rssi;       // receive signal strength in dBm
   NDIS_802_11_NETWORK_TYPE            NetworkTypeInUse;
   NDIS_802_11_CONFIGURATION           Configuration;
   NDIS_802_11_NETWORK_INFRASTRUCTURE  InfrastructureMode;
   NDIS_802_11_RATES                   SupportedRates;
} NDIS_WLAN_BSSID, *PNDIS_WLAN_BSSID;

typedef struct _NDIS_802_11_BSSID_LIST {
   ULONG           NumberOfItems;      // in list below, at least 1
   NDIS_WLAN_BSSID Bssid[1];
} NDIS_802_11_BSSID_LIST, *PNDIS_802_11_BSSID_LIST;

typedef  ULONG   NDIS_802_11_FRAGMENTATION_THRESHOLD;

typedef  ULONG   NDIS_802_11_RTS_THRESHOLD;

typedef  ULONG   NDIS_802_11_ANTENNA;

typedef enum _NDIS_802_11_PRIVACY_FILTER {
   Ndis802_11PrivFilterAcceptAll,
   Ndis802_11PrivFilter8021xWEP
} NDIS_802_11_PRIVACY_FILTER, *PNDIS_802_11_PRIVACY_FILTER;

typedef enum _NDIS_802_11_WEP_STATUS {
   Ndis802_11WEPEnabled,
    Ndis802_11Encryption1Enabled = Ndis802_11WEPEnabled,
   Ndis802_11WEPDisabled,
    Ndis802_11EncryptionDisabled = Ndis802_11WEPDisabled,
   Ndis802_11WEPKeyAbsent,
    Ndis802_11Encryption1KeyAbsent = Ndis802_11WEPKeyAbsent,
   Ndis802_11WEPNotSupported,
    Ndis802_11EncryptionNotSupported = Ndis802_11WEPNotSupported,
    Ndis802_11Encryption2Enabled,
    Ndis802_11Encryption2KeyAbsent,
} NDIS_802_11_WEP_STATUS, *PNDIS_802_11_WEP_STATUS,
  NDIS_802_11_ENCRYPTION_STATUS, *PNDIS_802_11_ENCRYPTION_STATUS;

typedef enum _NDIS_802_11_RELOAD_DEFAULTS {
   Ndis802_11ReloadWEPKeys
} NDIS_802_11_RELOAD_DEFAULTS, *PNDIS_802_11_RELOAD_DEFAULTS;

//#endif //of WIN 2k


typedef enum _RT_802_11_PREAMBLE {
    Rt802_11PreambleLong,
    Rt802_11PreambleShort,
    Rt802_11PreambleAuto
} RT_802_11_PREAMBLE, *PRT_802_11_PREAMBLE;

// put all proprietery for-query objects here to reduce # of Query_OID
typedef struct _RT_802_11_LINK_STATUS {
    ULONG   CurrTxRate;         // in units of 0.5Mbps
    ULONG   ChannelQuality;     // 0..100 %
    ULONG   TxByteCount;        // both ok and fail
    ULONG   RxByteCount;        // both ok and fail
} RT_802_11_LINK_STATUS, *PRT_802_11_LINK_STATUS;

// structure for query/set hardware register - MAC, BBP, RF register
typedef struct _RT_802_11_HARDWARE_REGISTER {
    ULONG   HardwareType;       // 0:MAC, 1:BBP, 2:RF register
    ULONG   Offset;             // Q/S register offset addr
    ULONG   Data;               // R/W data buffer
} RT_802_11_HARDWARE_REGISTER, *PRT_802_11_HARDWARE_REGISTER;

typedef struct _RT_VERSION_INFO{
	UCHAR		DriverMajorVersion;
	UCHAR		DriverMinorVersion;
	UCHAR		DriverSubVersion;	
	UINT		DriverBuildYear;
	UINT		DriverBuildMonth;
	UINT		DriverBuildDay;
} RT_VERSION_INFO, *PRT_VERSION_INFO;

typedef struct _RT_802_11_MAC_ENTRY {
    UCHAR       Addr[ETH_LENGTH_OF_ADDRESS];
    UCHAR       Aid;
    UCHAR       Psm;     // 0:PWR_ACTIVE, 1:PWR_SAVE
} RT_802_11_MAC_ENTRY, *PRT_802_11_MAC_ENTRY;

typedef struct _RT_802_11_MAC_TABLE {
    ULONG       Num;
    RT_802_11_MAC_ENTRY Entry[MAX_LEN_OF_MAC_TABLE];
} RT_802_11_MAC_TABLE, *PRT_802_11_MAC_TABLE;

#ifdef	WDS
typedef struct _RT_802_11_WDS {
    ULONG						Num;
    NDIS_802_11_MAC_ADDRESS		Entry[MAX_WDS_ENTRY];
	ULONG						KeyLength;
	UCHAR						KeyMaterial[32];
} RT_802_11_WDS, *PRT_802_11_WDS;
#endif

#endif
