/*
 ***************************************************************************
 * Ralink Tech Inc.
 * 4F, No. 2 Technology 5th Rd.
 * Science-based Industrial Park
 * Hsin-chu, Taiwan, R.O.C.
 *
 * (c) Copyright 2002, Ralink Technology, Inc.
 *
 * All rights reserved. Ralink's source code is an unpublished work and the
 * use of a copyright notice does not imply otherwise. This source code
 * contains confidential trade secret material of Ralink Tech. Any attemp
 * or participation in deciphering, decoding, reverse engineering or in any
 * way altering the source code is stricitly prohibited, unless the prior
 * written consent of Ralink Technology, Inc. is obtained.
 ***************************************************************************

	Module Name:
	rtmp_info.c

	Abstract:
	IOCTL related subroutines

	Revision History:
	Who         When          What
	--------    ----------    ----------------------------------------------
	Rory Chen   01-03-2003    created

*/

#include	"rt_config.h"

struct iw_priv_args privtab[] = {
{ RTPRIV_IOCTL_SET, 
  IW_PRIV_TYPE_CHAR | 1024, 0,
  "set"},
#ifdef RT2500_DBG
{ RTPRIV_IOCTL_BBP,
  IW_PRIV_TYPE_CHAR | 1024, IW_PRIV_TYPE_CHAR | 1024,
  "bbp"},
{ RTPRIV_IOCTL_MAC,
  IW_PRIV_TYPE_CHAR | 1024, IW_PRIV_TYPE_CHAR | 1024,
  "mac"},
{ RTPRIV_IOCTL_E2P,
  IW_PRIV_TYPE_CHAR | 1024, IW_PRIV_TYPE_CHAR | 1024,
  "e2p"},
{ RTPRIV_IOCTL_STATISTICS,
  IW_PRIV_TYPE_CHAR | 1024, IW_PRIV_TYPE_CHAR | 1024,
  "stat"}
#endif
};

static struct {
	char *name;
	int (*set_proc)(PRTMP_ADAPTER pAdapter, PUCHAR arg);
} *PRTMP_PRIVATE_SET_PROC, RTMP_PRIVATE_SUPPORT_PROC[] = {
	{"ssid", Set_SSID_Proc},
	{"auth", Set_AuthMode_Proc},
	{"enc", Set_EncrypType_Proc},     
	{"DefaultKeyID", Set_DefaultKeyID_Proc},
	{"Key1", Set_Key1_Proc},
	{"Key2", Set_Key2_Proc},
	{"Key3", Set_Key3_Proc},
	{"Key4", Set_Key4_Proc},
	{"psk", Set_WPAPSK_Proc},
	{"rekeytype", Set_RekeyType_Proc},
	{"rekeyperiod", Set_RekeyPeriod_Proc},
	{NULL,}
};
//	{"AuthMode", Set_AuthMode_Proc},
//	{"EncrypType", Set_EncrypType_Proc},
INT RTMPSetInformation(
	IN	PRTMP_ADAPTER pAdapter,
	IN	OUT	struct ifreq	*rq,
	IN	INT					cmd)
{
	struct iwreq						*wrq = (struct iwreq *) rq;
	INT									Status = NDIS_STATUS_SUCCESS;
    
	switch(cmd & 0x7FFF) 
    {

    }
	return Status;

}

INT RTMPQueryInformation(
	IN	PRTMP_ADAPTER       pAdapter,
	IN	OUT	struct ifreq    *rq,
	IN	INT                 cmd)
{
	struct iwreq						*wrq = (struct iwreq *) rq;
    INT									Status = NDIS_STATUS_SUCCESS;
    ULONG								ulInfo = 0;
	return Status;
}

INT RT2400_ioctl(
	IN	struct net_device	*net_dev, 
	IN	OUT	struct ifreq	*rq, 
	IN	INT					cmd)
{
	PRTMP_ADAPTER						pAd= net_dev->priv;
	struct iwreq						*wrq = (struct iwreq *) rq;
	BOOLEAN								RestartAPIsRequired = FALSE;
	UCHAR								TxValue,RxValue;
	USHORT								subcmd;
	ULONG								BssLen, ulInfo, KeyIdx, Rssi, Preamble, FcsValue, Now, ifs;
	PTXD_STRUC							pTxD;
	INT									testmode, Status = NDIS_STATUS_SUCCESS;
	UINT								i;
	NDIS_802_11_RTS_THRESHOLD			RtsThresh;
	NDIS_802_11_FRAGMENTATION_THRESHOLD	FragThresh;
	NDIS_802_11_BSSID_LIST				*pBssidList = NULL;
	NDIS_802_11_MAC_ADDRESS				Bssid;
	NDIS_802_11_CONFIGURATION			Configuration;
	NDIS_802_11_SSID                    Ssid;
	NDIS_802_11_NETWORK_INFRASTRUCTURE	BssType;
	NDIS_802_11_ANTENNA					Antenna;
	NDIS_802_11_RATES					Rates;
	NDIS_802_11_TX_POWER_LEVEL			TxPowerLevel;
	NDIS_802_11_AUTHENTICATION_MODE		AuthMode;
	NDIS_802_11_WEP_STATUS				WepStatus;
	//NDIS_802_11_WEP						WepKey;
	NDIS_802_11_CONFIGURATION			Config;
	NDIS_802_11_POWER_MODE				PowerMode;
	NDIS_802_11_STATISTICS				Statistics;
	RT_802_11_LINK_STATUS				LinkStatus;
	RT_VERSION_INFO						DriverVersionInfo;
	RT_802_11_HARDWARE_REGISTER			HardwareRegister;
	RT_802_11_MAC_TABLE					MacTab;
	NDIS_802_11_KEY						WepKey, *pKey=NULL;
    
	if(!RTMP_TEST_FLAG(pAd, fRTMP_ADAPTER_INTERRUPT_IN_USE))
	{
		DBGPRINT(RT_DEBUG_TRACE, "INFO::Network is down!\n");
		return -ENETDOWN;
	}
	subcmd=wrq->u.data.flags;
	
	switch(cmd) {
		case SIOCGIWNAME:
			DBGPRINT(RT_DEBUG_TRACE, "INFO::SIOCGIWNAME\n");
			strcpy(wrq->u.name, "RT2400PCI");   
			break;
			
		case SIOCGIWESSID:
			wrq->u.essid.flags = 1;
			wrq->u.essid.length = pAd->PortCfg.SsidLen;
			copy_to_user(wrq->u.essid.pointer, pAd->PortCfg.Ssid, wrq->u.essid.length);
            DBGPRINT(RT_DEBUG_TRACE, "INFO::SIOCGIWESSID (Len=%d, ssid=%s...)\n", wrq->u.essid.length, wrq->u.essid.pointer);
			break;

		case SIOCSIWESSID:
			if (((wrq->u.data.length - 1) > 0) && ((wrq->u.data.length - 1) <= 32))
            {
		        memcpy(pAd->PortCfg.Ssid, wrq->u.data.pointer,
			       wrq->u.data.length - 1);
				pAd->PortCfg.SsidLen = wrq->u.data.length - 1;
				RestartAPIsRequired = TRUE;

				DBGPRINT(RT_DEBUG_TRACE, "INFO::SIOCSIWESSID (Len=%d,Ssid=%s)\n", pAd->PortCfg.SsidLen, pAd->PortCfg.Ssid);
			}
			else
	        {
	        	Status = -EINVAL;
	        }
			break;

		case SIOCGIWNWID:
			Status = -EOPNOTSUPP;
			break;

		case SIOCSIWNWID:
			Status = -EOPNOTSUPP;
			break;

		case SIOCGIWRTS:
			wrq->u.rts.value = (INT) pAd->PortCfg.RtsThreshold;
			break;

		case SIOCSIWRTS:
			if (wrq->u.rts.disabled == 1)
				pAd->PortCfg.RtsThreshold = MAX_RTS_THRESHOLD;
			else if (RtsThresh > MAX_RTS_THRESHOLD)
				Status = -EINVAL;
			else 
				pAd->PortCfg.RtsThreshold = (USHORT) wrq->u.rts.value;

			DBGPRINT(RT_DEBUG_TRACE, "INFO::SIOCSIWRTS (=%d)\n", pAd->PortCfg.RtsThreshold);
			break;

		case SIOCGIWFRAG:
			wrq->u.frag.value = pAd->PortCfg.FragmentThreshold;
                        if (pAd->PortCfg.bFragmentZeroDisable == TRUE)
            	                wrq->u.frag.value = 0;
			break;
			
		case SIOCSIWFRAG:
			FragThresh = *(NDIS_802_11_FRAGMENTATION_THRESHOLD *) &wrq->u.frag.value;
            pAd->PortCfg.bFragmentZeroDisable = FALSE;
            if (FragThresh > MAX_FRAG_THRESHOLD || FragThresh < MIN_FRAG_THRESHOLD)
            {
	                if (FragThresh == 0)
	                {
		               pAd->PortCfg.FragmentThreshold = MAX_FRAG_THRESHOLD;
		               pAd->PortCfg.bFragmentZeroDisable = TRUE;
	                }
	                else
    	               Status = -EINVAL;
            }
            else
                    pAd->PortCfg.FragmentThreshold = (USHORT)FragThresh;

            DBGPRINT(RT_DEBUG_TRACE, "INFO::SIOCSIWFRAG (=%d)\n", pAd->PortCfg.FragmentThreshold);
	        break;
			
#if WIRELESS_EXT > 11
		case SIOCGIWSTATS:
			// TODO: Get /proc/net/wireless stats
			Status = -EOPNOTSUPP;
			break;

		case SIOCSIWSTATS:
			Status = -EOPNOTSUPP;
			break;
#endif
		case SIOCGIWAP:
            wrq->u.ap_addr.sa_data[0]  = pAd->PortCfg.Bssid.Octet[0];
            wrq->u.ap_addr.sa_data[1]  = pAd->PortCfg.Bssid.Octet[1];
            wrq->u.ap_addr.sa_data[2]  = pAd->PortCfg.Bssid.Octet[2];
            wrq->u.ap_addr.sa_data[3]  = pAd->PortCfg.Bssid.Octet[3];
            wrq->u.ap_addr.sa_data[4]  = pAd->PortCfg.Bssid.Octet[4];
            wrq->u.ap_addr.sa_data[5]  = pAd->PortCfg.Bssid.Octet[5];
            wrq->u.ap_addr.sa_family = ARPHRD_ETHER;

            DBGPRINT(RT_DEBUG_TRACE, "INFO::SIOCGIWAP(=%02x:%02x:%02x:%02x:%02x:%02x)\n",
                  pAd->PortCfg.Bssid.Octet[0],pAd->PortCfg.Bssid.Octet[1],pAd->PortCfg.Bssid.Octet[2],
                  pAd->PortCfg.Bssid.Octet[3],pAd->PortCfg.Bssid.Octet[4],pAd->PortCfg.Bssid.Octet[5]);
			break;

		case SIOCSIWAP:
			Status = -EOPNOTSUPP;
			break;

		case SIOCGIWFREQ:		
			wrq->u.freq.m = 2412 + (pAd->PortCfg.Channel - 1) * 5;
			wrq->u.freq.e = 6;
			wrq->u.freq.i = 0;
			break;

		case SIOCSIWFREQ:
			if ((wrq->u.freq.e == 0) && (wrq->u.freq.m <= 1000))
			{
				pAd->PortCfg.Channel = wrq->u.freq.m;
			}
			else
			{
				ULONG	freq;

				freq = wrq->u.freq.m * (10 ^ wrq->u.freq.e);

				if (freq == 2484000)
        			        pAd->PortCfg.Channel = 14;
				else if (freq >= 2412000 && freq < 2484000) 
        			        pAd->PortCfg.Channel = (UCHAR)((Config.DSConfig - 2412000) / 5000) + 1;
			        else
				        Status = -EINVAL;
			}

			DBGPRINT(RT_DEBUG_TRACE, "INFO::SIOCSIWFREQ (Channel=%d)\n",pAd->PortCfg.Channel);
			break;

		case SIOCGIWRATE:
			if (pAd->PortCfg.TxRate == RATE_1)
                   wrq->u.bitrate.value = 1000000;
            else if (pAd->PortCfg.TxRate == RATE_2)
                   wrq->u.bitrate.value = 2000000;
            else if (pAd->PortCfg.TxRate == RATE_5_5)
                   wrq->u.bitrate.value = 5500000;
            else
                   wrq->u.bitrate.value = 11000000;
            DBGPRINT(RT_DEBUG_TRACE, "INFO::SIOCGIWRATE (rate=%d)\n", wrq->u.bitrate.value);
			break;

		case SIOCSIWRATE:
			Status = -EOPNOTSUPP;
			break;

		case SIOCGIWENCODE:
			wrq->u.encoding.flags = (pAd->PortCfg.WepStatus == Ndis802_11WEPEnabled) ? IW_ENCODE_RESTRICTED : IW_ENCODE_OPEN;
			if(pAd->PortCfg.WepStatus ==  Ndis802_11WEPDisabled)
				wrq->u.encoding.flags |= IW_ENCODE_DISABLED;
       
			i = (wrq->u.encoding.flags & IW_ENCODE_INDEX) - 1;

			if ((i < 0) || (i >= SHARE_KEY_NO))
			{
				Status = -EINVAL;
			}
			else
			{
				wrq->u.encoding.flags |= i + 1;	/* copy the key from the driver cache as the keys are read-only MIBs */	
				wrq->u.data.length = pAd->PortCfg.SharedKey[KeyIdx].KeyLen;
				copy_to_user(wrq->u.data.pointer, &pAd->PortCfg.SharedKey[i].Key, wrq->u.data.length);
			}
			DBGPRINT(RT_DEBUG_TRACE, "INFO::SIOCGIWENCODE(=%d)\n", wrq->u.encoding.flags);
			
			break;
			
		case SIOCSIWENCODE:
            pAd->PortCfg.WepStatus = (wrq->u.encoding.flags & IW_ENCODE_DISABLED) ? 1 : 0;

            KeyIdx = (wrq->u.encoding.flags & IW_ENCODE_INDEX) - 1;

			if (KeyIdx > 4)
				Status = -EINVAL;
			else
			{
				pAd->PortCfg.SharedKey[KeyIdx].KeyLen = (UCHAR) wrq->u.data.length;
				NdisMoveMemory(pAd->PortCfg.SharedKey[KeyIdx].Key, wrq->u.data.pointer, pAd->PortCfg.SharedKey[KeyIdx].KeyLen);
			}
			break;
	
		case SIOCGIWPOWER:
		case SIOCSIWPOWER:
			Status = -EOPNOTSUPP;
			break;
			
		case SIOCGIWTXPOW:
			wrq->u.txpower.value = (__s32)pAd->PortCfg.TxPower;
			wrq->u.txpower.flags = 0;
			wrq->u.txpower.disabled = 0;
			wrq->u.txpower.fixed = 0;
    		        DBGPRINT(RT_DEBUG_TRACE, "INFO::SIOCGIWTXPOW(=%d)\n", wrq->u.txpower.value);
    		        break;
    		
		case SIOCSIWTXPOW:
			if ((wrq->u.txpower.value > MAX_TX_POWER_LEVEL) && (wrq->u.txpower.disabled == 0))
                                Status = -EINVAL;
                        else
                        {
                                pAd->PortCfg.TxPower = (UCHAR)wrq->u.txpower.value;
            	                RTMP_BBP_IO_WRITE32_BY_REG_ID(pAd, BBP_Tx_Power, pAd->PortCfg.TxPower);
                        }
                        DBGPRINT(RT_DEBUG_TRACE, "INFO::SIOCSIWTXPOW(=%d)\n", wrq->u.txpower.value);
			break;

		case SIOCGIWMODE:
				wrq->u.mode = IW_MODE_INFRA;
			break;
			
		case SIOCSIWMODE:
			Status = -EOPNOTSUPP;
			break;

		case SIOCGIWPRIV:
			if (wrq->u.data.pointer) {
				if ( verify_area(VERIFY_WRITE, wrq->u.data.pointer, sizeof(privtab)) )
					break;
				wrq->u.data.length = sizeof(privtab) / sizeof(privtab[0]);
				if (copy_to_user(wrq->u.data.pointer, privtab, sizeof(privtab)))
					Status = -EFAULT;
			}
            DBGPRINT(RT_DEBUG_TRACE, "INFO::SIOCGIWPRIV\n");
			break;
		case RTPRIV_IOCTL_SET:
            DBGPRINT(RT_DEBUG_TRACE, "INFO::RTPRIV_IOCTL_SET\n");
			{				
				char *this_char;
				char *value;

				if( verify_area(VERIFY_READ, wrq->u.data.pointer, wrq->u.data.length) )
					break;

				while ((this_char = strsep(&wrq->u.data.pointer, ",")) != NULL) 
				{
					if (!*this_char)
						 continue;

					if ((value = strchr(this_char, '=')) != NULL)
						*value++ = 0;

					if (!value || !*value)
						continue;  							

					for (PRTMP_PRIVATE_SET_PROC = RTMP_PRIVATE_SUPPORT_PROC; PRTMP_PRIVATE_SET_PROC->name; PRTMP_PRIVATE_SET_PROC++)
					{
						if (!strcmp(this_char, PRTMP_PRIVATE_SET_PROC->name)) 
						{						
							if(!PRTMP_PRIVATE_SET_PROC->set_proc(pAd, value))
							{   //FALSE:Set private failed then return Invalid argument 								
								Status = -EINVAL;							
							}
							break;  //Exit for loop.
						}
					}

					if(PRTMP_PRIVATE_SET_PROC->name == NULL)
					{  //Not found argument
						Status = -EINVAL;
						DBGPRINT(RT_DEBUG_TRACE, "IOCTL::(iwpriv) Not Support Set Command [%s=%s]\n", this_char, value);
						break;
					}	
				}
			}
			break;
		case RT_PRIV_IOCTL:
#if 0
 			subcmd = wrq->u.data.flags;
			if( subcmd & OID_GET_SET_TOGGLE)
				Status = RTMPSetInformation(pAd, rq, subcmd);
			else
				Status = RTMPQueryInformation(pAd, rq, subcmd);
			break;
#endif
           DBGPRINT(RT_DEBUG_TRACE, "INFO::RT_PRIV_IOCTL\n");
			subcmd = wrq->u.data.flags;
            switch(subcmd)
                {
            case OID_802_11_ADD_KEY:
			copy_from_user(&WepKey, wrq->u.data.pointer, wrq->u.data.length);
			pKey = &WepKey;

			if (pAd->PortCfg.AuthMode >= Ndis802_11AuthModeWPA)
			{
				if(pKey->KeyLength==32)
				{
					NdisMoveMemory(pAd->PortCfg.PMK, pKey->KeyMaterial, 32);
                    DBGPRINT(RT_DEBUG_TRACE, "  after ADD_KEY :  PMK = %x %x %x %x \n",pAd->PortCfg.PMK[0],pAd->PortCfg.PMK[1],pAd->PortCfg.PMK[2],pAd->PortCfg.PMK[3]);
#ifdef RT2400_DBG
					printk("OID_802_11_ADD_KEY:: Key=>\n");
					for (i = 0; i < 32; i++)
					{
						printk("%02x:", pAd->PortCfg.PMK[i]);
						if ((i%16) == 15)
							printk("\n");
					}
					printk("\n");
#endif
				}
				else
                    DBGPRINT(RT_DEBUG_TRACE, "Set::OID_802_11_ADD_KEY ERROR \n");
			}
			DBGPRINT(RT_DEBUG_TRACE, "Set::OID_802_11_ADD_KEY (info-len=%d, id=0x%x, Len=%d-byte)\n", wrq->u.data.length, pKey->KeyIndex, pKey->KeyLength);
			break;
		        case RT_OID_802_11_RADIUS_DATA:
			    {
		                DBGPRINT(RT_DEBUG_TRACE, " !!!!!SET :: RT_OID_802_11_RADIUS_DATA !!!!!!!!!!!!!      \n");
		                DBGPRINT(RT_DEBUG_TRACE, " wrq->u.data.length = %d = 0x%x \n",wrq->u.data.length,wrq->u.data.length);
		                DBGPRINT(RT_DEBUG_TRACE, " wrq->u.data = %x %x \n",*(wrq->u.data.pointer+12),*(wrq->u.data.pointer+13));

		                if (pAd->PortCfg.AuthMode == Ndis802_11AuthModeWPA)
		                    WpaSend(pAd, wrq->u.data.pointer, wrq->u.data.length);                
			            break;
				}
				case RTLINUX_SET_OID_802_11_BSSID_LIST_SCAN:
					DBGPRINT(RT_DEBUG_TRACE, "INFO::RTLINUX_SET_OID_802_11_BSSID_LIST_SCAN\n");
					break;

				case RTLINUX_GET_OID_802_11_BSSID_LIST:
					BssLen = pAd->PortCfg.BssTab.BssNr * sizeof(NDIS_WLAN_BSSID) + sizeof(ULONG);
					pBssidList = (PNDIS_802_11_BSSID_LIST) kmalloc(BssLen, GFP_KERNEL);
					if(pBssidList == NULL)
					{
		                Status = -ENOMEM;
		                break;
		            }
		            memset(pBssidList, 0, BssLen);
		            
					pBssidList->NumberOfItems = pAd->PortCfg.BssTab.BssNr;
										
					for (i = 0; i < pAd->PortCfg.BssTab.BssNr; i++) 
					{
						pBssidList->Bssid[i].Length = sizeof(NDIS_WLAN_BSSID);
		                memmove(&pBssidList->Bssid[i].MacAddress, &pAd->PortCfg.BssTab.BssEntry[i].Bssid, MAC_ADDR_LEN);
		                pBssidList->Bssid[i].Ssid.SsidLength = pAd->PortCfg.BssTab.BssEntry[i].SsidLen;
		                memmove(pBssidList->Bssid[i].Ssid.Ssid, pAd->PortCfg.BssTab.BssEntry[i].Ssid, pAd->PortCfg.BssTab.BssEntry[i].SsidLen);
		                pBssidList->Bssid[i].Privacy = pAd->PortCfg.BssTab.BssEntry[i].Privacy;
		                pBssidList->Bssid[i].Rssi = pAd->PortCfg.BssTab.BssEntry[i].Rssi - RSSI_TO_DBM_OFFSET;
		                pBssidList->Bssid[i].NetworkTypeInUse = Ndis802_11DS;
		                pBssidList->Bssid[i].Configuration.Length = sizeof(NDIS_802_11_CONFIGURATION);
		                pBssidList->Bssid[i].Configuration.BeaconPeriod = pAd->PortCfg.BssTab.BssEntry[i].BeaconPeriod;
		                pBssidList->Bssid[i].Configuration.ATIMWindow = pAd->PortCfg.BssTab.BssEntry[i].AtimWin;
						if (pAd->PortCfg.BssTab.BssEntry[i].Channel == 14)
							pBssidList->Bssid[i].Configuration.DSConfig = 2484000; 
						else
							pBssidList->Bssid[i].Configuration.DSConfig = 2412000 + (pAd->PortCfg.BssTab.BssEntry[i].Channel - 1) * 5000; 
				
		                if(pAd->PortCfg.BssTab.BssEntry[i].BssType == BSS_INFRA) 
		                    pBssidList->Bssid[i].InfrastructureMode = Ndis802_11Infrastructure;
		                else 
		                    pBssidList->Bssid[i].InfrastructureMode = Ndis802_11IBSS;

		                memmove(pBssidList->Bssid[i].SupportedRates, pAd->PortCfg.BssTab.BssEntry[i].Rates, pAd->PortCfg.BssTab.BssEntry[i].RatesLen);

		                DBGPRINT(RT_DEBUG_INFO,"INFO::RTLINUX_GET_OID_802_11_BSSID_LIST (BSS[%d], MAC = %02x:%02x:%02x:%02x:%02x:%02x, Ssid:%s)\n",
							i,
							pBssidList->Bssid[i].MacAddress[0],
                            pBssidList->Bssid[i].MacAddress[1],
                            pBssidList->Bssid[i].MacAddress[2],
                            pBssidList->Bssid[i].MacAddress[3],
                            pBssidList->Bssid[i].MacAddress[4],
                            pBssidList->Bssid[i].MacAddress[5],
                            pBssidList->Bssid[i].Ssid.Ssid);
					}
					
					wrq->u.data.length = BssLen;
					copy_to_user(wrq->u.data.pointer, pBssidList, wrq->u.data.length);
					break;

				case RTLINUX_GET_MEDIA_CONNECT_STATUS:
		            DBGPRINT(RT_DEBUG_INFO, "INFO::RTLINUX_GET_MEDIA_CONNECT_STATUS \n");
					wrq->u.data.length=sizeof(NDIS_MEDIA_STATE);
					copy_to_user(wrq->u.data.pointer, &pAd->MediaState, wrq->u.data.length);
					break;

				case RTLINUX_GET_OID_802_11_BSSID:
		            {
		                COPY_MAC_ADDR(&Bssid, &pAd->PortCfg.Bssid);
		                DBGPRINT(RT_DEBUG_TRACE, "INFO::RTLINUX_GET_OID_802_11_BSSID(=%02x:%02x:%02x:%02x:%02x:%02x)\n",
		                         Bssid[0],Bssid[1],Bssid[2],Bssid[3],Bssid[4],Bssid[5]);
		                wrq->u.data.length = MAC_ADDR_LEN;
		                copy_to_user(wrq->u.data.pointer, &Bssid, wrq->u.data.length);
		            } 
		            break;

				case RTLINUX_SET_OID_802_11_BSSID:
					DBGPRINT(RT_DEBUG_TRACE, "INFO::RTLINUX_SET_OID_802_11_BSSID\n");
		            break;

				case RTLINUX_GET_OID_802_11_SSID:
					Ssid.SsidLength = pAd->PortCfg.SsidLen;
        		    memmove(Ssid.Ssid, pAd->PortCfg.Ssid, Ssid.SsidLength);
		            DBGPRINT(RT_DEBUG_TRACE, "INFO::RTLINUX_GET_OID_802_11_SSID (Len=%d, ssid=%s...)\n", Ssid.SsidLength,Ssid.Ssid);

					wrq->u.data.length=sizeof(NDIS_802_11_SSID);
					copy_to_user(wrq->u.data.pointer, &Ssid, wrq->u.data.length);
					break;

				case RTLINUX_GET_OID_802_11_CONFIGURATION:
					Configuration.Length = sizeof(NDIS_802_11_CONFIGURATION);
					Configuration.BeaconPeriod = pAd->PortCfg.BeaconPeriod;
					Configuration.ATIMWindow = pAd->PortCfg.AtimWin;
					if (pAd->PortCfg.Channel == 14)
						Configuration.DSConfig = 2484000;
					else
						Configuration.DSConfig = 2412000 + (pAd->PortCfg.Channel - 1) * 5000;
					
					DBGPRINT(RT_DEBUG_TRACE, "INFO::RTLINUX_GET_OID_802_11_CONFIGURATION(BeaconPeriod=%d,AtimW=%d,Channel=%d) \n",
						Configuration.BeaconPeriod, Configuration.ATIMWindow, pAd->PortCfg.Channel);
					wrq->u.data.length = sizeof(NDIS_802_11_CONFIGURATION);
					copy_to_user(wrq->u.data.pointer, &Configuration, wrq->u.data.length);
					break;
				
				case RTLINUX_GET_RT_OID_802_11_QUERY_LINK_STATUS:
					DBGPRINT(RT_DEBUG_TRACE, "INFO::RTLINUX_GET_RT_OID_802_11_QUERY_LINK_STATUS\n");
					if (pAd->PortCfg.TxRate == RATE_1)
		                LinkStatus.CurrTxRate = 2;  // unit: 500 kbps
		            else if (pAd->PortCfg.TxRate == RATE_2)
		                LinkStatus.CurrTxRate = 4;  // unit: 500 kbps
		            else if (pAd->PortCfg.TxRate == RATE_5_5)
		                LinkStatus.CurrTxRate = 11; // unit: 500 kbps
		            else
		                LinkStatus.CurrTxRate = 22; // unit: 500 kbps
		            LinkStatus.ChannelQuality = pAd->Mlme.RoamCqi;
		            LinkStatus.RxByteCount = pAd->RalinkCounters.ReceivedByteCount;
		            LinkStatus.TxByteCount = pAd->RalinkCounters.TransmittedByteCount;
							
					wrq->u.data.length = sizeof(RT_802_11_LINK_STATUS);
					copy_to_user(wrq->u.data.pointer, &LinkStatus, wrq->u.data.length);
					break;

				case RTLINUX_GET_OID_802_11_RSSI:
					Rssi = pAd->PortCfg.LastRssi - RSSI_TO_DBM_OFFSET;
					wrq->u.data.length = sizeof(NDIS_802_11_RSSI);
					copy_to_user(wrq->u.data.pointer, &Rssi, wrq->u.data.length);
					DBGPRINT(RT_DEBUG_TRACE, "INFO::RTLINUX_GET_OID_802_11_RSSI(=%d)\n", Rssi);
					break;

				case RTLINUX_GET_OID_802_11_INFRASTRUCTURE_MODE:
	                ulInfo = Ndis802_11Infrastructure;
										
					wrq->u.data.length = sizeof(NDIS_802_11_NETWORK_INFRASTRUCTURE);
					copy_to_user(wrq->u.data.pointer, &ulInfo, wrq->u.data.length);

					DBGPRINT(RT_DEBUG_TRACE, "INFO::RTLINUX_GET_OID_802_11_INFRASTRUCTURE_MODE(=%d)\n", ulInfo);
					break;

				case RTLINUX_SET_OID_802_11_INFRASTRUCTURE_MODE:
					break;

				case RTLINUX_GET_OID_802_11_TX_ANTENNA_SELECTED:
					if (pAd->PortCfg.CurrentTxAntenna == 0xff)
						ulInfo = 0xffffffff;
					else
						ulInfo = pAd->PortCfg.CurrentTxAntenna;

					wrq->u.data.length = sizeof(ulInfo);
					copy_to_user(wrq->u.data.pointer, &ulInfo, wrq->u.data.length);

					DBGPRINT(RT_DEBUG_TRACE, "INFO::RTLINUX_GET_OID_802_11_TX_ANTENNA_SELECTED(=%d)\n", ulInfo);
					break;

				case RTLINUX_SET_OID_802_11_TX_ANTENNA_SELECTED:
					if (wrq->u.data.length != sizeof(NDIS_802_11_ANTENNA)) 
		                Status = -EINVAL;
		            else 
		            {
		            	copy_from_user(&Antenna, wrq->u.data.pointer, wrq->u.data.length);
		                if (Antenna == 0xFFFFFFFF) 
						{// Diversity
							pAd->PortCfg.CurrentTxAntenna = (UCHAR)Antenna;
							RTMP_BBP_IO_READ32_BY_REG_ID(pAd, BBP_Tx_Configure, &TxValue);
                			TxValue = (TxValue & 0xFC) | 0x01;
                			RTMP_BBP_IO_WRITE32_BY_REG_ID(pAd, BBP_Tx_Configure, TxValue);
						} 
						else if (Antenna >= pAd->PortCfg.NumberOfAntenna)
							Status = -EINVAL;
						else
						{
							pAd->PortCfg.CurrentTxAntenna = (UCHAR)Antenna;

							RTMP_BBP_IO_READ32_BY_REG_ID(pAd, BBP_Tx_Configure, &TxValue);
							if(Antenna == 0)
							{// Antenna A
								TxValue = (TxValue & 0xFC) | 0x00;
							}
							else if(Antenna == 1)
							{// Antenna B
								TxValue = (TxValue & 0xFC) | 0x02;
							}
                			RTMP_BBP_IO_WRITE32_BY_REG_ID(pAd, BBP_Tx_Configure, TxValue);
						}
		            }
		            DBGPRINT(RT_DEBUG_INFO, "INFO::RTLINUX_SET_OID_802_11_TX_ANTENNA_SELECTED (=%d) \n",Antenna);
		            break;

				case RTLINUX_GET_OID_802_11_RX_ANTENNA_SELECTED:
					if (pAd->PortCfg.CurrentRxAntenna == 0xff)
						ulInfo = 0xffffffff;
					else
						ulInfo = pAd->PortCfg.CurrentRxAntenna;

					wrq->u.data.length = sizeof(ulInfo);
					copy_to_user(wrq->u.data.pointer, &ulInfo, wrq->u.data.length);

					DBGPRINT(RT_DEBUG_TRACE, "INFO::RTLINUX_GET_OID_802_11_RX_ANTENNA_SELECTED(=%d)\n", ulInfo);
            		break;

            	case RTLINUX_SET_OID_802_11_RX_ANTENNA_SELECTED:
					if (wrq->u.data.length != sizeof(NDIS_802_11_ANTENNA))
		                Status = -EINVAL;
		            else 
		            {
		            	copy_from_user(&Antenna, wrq->u.data.pointer, wrq->u.data.length);
		                if(Antenna == 0xFFFFFFFF) 
						{// Diversity
							pAd->PortCfg.CurrentRxAntenna = (UCHAR)Antenna;
                			RTMP_BBP_IO_READ32_BY_REG_ID(pAd, BBP_Rx_Configure, &RxValue);
                			RxValue = (RxValue & 0xF9) | 0x02;
                			RTMP_BBP_IO_WRITE32_BY_REG_ID(pAd, BBP_Rx_Configure, RxValue);
						} 
						else if(Antenna >= pAd->PortCfg.NumberOfAntenna)
							Status = -EINVAL;
						else
						{
							pAd->PortCfg.CurrentRxAntenna = (UCHAR)Antenna;
                    
							RTMP_BBP_IO_READ32_BY_REG_ID(pAd, BBP_Rx_Configure, &RxValue);
							if(Antenna == 0)
							{// Antenna A
								RxValue = (RxValue & 0xF9) | 0x00;
							}
							else if(Antenna == 1)
							{// Antenna B
								RxValue = (RxValue & 0xF9) | 0x04;
							}
                			RTMP_BBP_IO_WRITE32_BY_REG_ID(pAd, BBP_Rx_Configure, RxValue);
						}
		            }
		            DBGPRINT(RT_DEBUG_TRACE, "INFO::RTLINUX_SET_OID_802_11_RX_ANTENNA_SELECTED (=%d)\n",Antenna);
		            break;

				case RTLINUX_GET_OID_802_11_DESIRED_RATES:
					wrq->u.data.length = sizeof(NDIS_802_11_RATES);
					copy_to_user(wrq->u.data.pointer, &pAd->PortCfg.DesiredRates, wrq->u.data.length);
		            DBGPRINT(RT_DEBUG_INFO, "INFO::RTLINUX_GET_OID_802_11_DESIRED_RATES (%d,%d,%d,%d,%d,%d,%d,%d)\n",
		                Rates[0],Rates[1],Rates[2],Rates[3],Rates[4],Rates[5],Rates[6],Rates[7]);
					break;

				case RTLINUX_SET_OID_802_11_DESIRED_RATES:
					if (wrq->u.data.length != sizeof(NDIS_802_11_RATES)) 
		                Status = -EINVAL;
		            else
		            {
		            	copy_from_user(&pAd->PortCfg.DesiredRates, wrq->u.data.pointer, wrq->u.data.length);
		                // Changing DesiredRate may affect the MAX TX rate we used to TX frames out
		                MlmeUpdateTxRates(pAd);
		            }
		            DBGPRINT(RT_DEBUG_TRACE, "INFO::RTLINUX_SET_OID_802_11_DESIRED_RATES (%02x,%02x,%02x,%02x,%02x,%02x,%02x,%02x)\n",
		                pAd->PortCfg.DesiredRates[0],pAd->PortCfg.DesiredRates[1],
		                pAd->PortCfg.DesiredRates[2],pAd->PortCfg.DesiredRates[3],
		                pAd->PortCfg.DesiredRates[4],pAd->PortCfg.DesiredRates[5],
		                pAd->PortCfg.DesiredRates[6],pAd->PortCfg.DesiredRates[7] );
					break;

				case RTLINUX_GET_OID_802_11_QUERY_PREAMBLE:
					ulInfo = pAd->PortCfg.TxPreamble;
					wrq->u.data.length = sizeof(RT_802_11_PREAMBLE);
					copy_to_user(wrq->u.data.pointer, &ulInfo, wrq->u.data.length);
            		DBGPRINT(RT_DEBUG_TRACE, "INFO::RTLINUX_GET_OID_802_11_QUERY_PREAMBLE(=%d)\n", ulInfo);
            		break;

				case RTLINUX_SET_OID_802_11_SET_PREAMBLE:
					if (wrq->u.data.length != sizeof(ULONG))
		                Status = -EINVAL;
		            else 
		            {
		            	copy_from_user(&Preamble, wrq->u.data.pointer, wrq->u.data.length);
		                if (Preamble == Rt802_11PreambleShort)
		                {
		                    pAd->PortCfg.WindowsTxPreamble = Preamble;
		                    MlmeSetTxPreamble(pAd, Rt802_11PreambleShort);
		                }
		                else if ((Preamble == Rt802_11PreambleLong) || (Preamble == Rt802_11PreambleAuto))
		                {
		                    // if user wants AUTO, initialize to LONG here, then change according to AP's
		                    // capability upon association.
		                    pAd->PortCfg.WindowsTxPreamble = Preamble;
		                    MlmeSetTxPreamble(pAd, Rt802_11PreambleLong);
		                }
		                else
		                    Status = -EINVAL;
		            }
		            DBGPRINT(RT_DEBUG_TRACE, "INFO::RTLINUX_SET_OID_802_11_SET_PREAMBLE (=%d)\n", Preamble);
					break;

				case RTLINUX_GET_OID_802_11_TX_POWER_LEVEL:
					ulInfo = (ULONG)pAd->PortCfg.TxPower;
					wrq->u.data.length = sizeof(NDIS_802_11_TX_POWER_LEVEL);
					copy_to_user(wrq->u.data.pointer, &ulInfo, wrq->u.data.length);
            		DBGPRINT(RT_DEBUG_TRACE, "INFO::RTLINUX_GET_OID_802_11_TX_POWER_LEVEL(=%d)\n", ulInfo);
            		break;

            	case RTLINUX_SET_OID_802_11_TX_POWER_LEVEL:
            		if (wrq->u.data.length != sizeof(NDIS_802_11_TX_POWER_LEVEL)) 
		                Status = -EINVAL;
		            else 
		            {
		            	copy_from_user(&TxPowerLevel, wrq->u.data.pointer, wrq->u.data.length);
		                if (TxPowerLevel > MAX_TX_POWER_LEVEL)
		                    Status = -EINVAL;
		                else
		                    pAd->PortCfg.TxPower = (UCHAR)TxPowerLevel;
		            }
		            DBGPRINT(RT_DEBUG_TRACE, "INFO::RTLINUX_SET_OID_802_11_TX_POWER_LEVEL (=%d) \n",TxPowerLevel);
		            break;

				case RTLINUX_GET_OID_802_11_RTS_THRESHOLD:
					ulInfo = pAd->PortCfg.RtsThreshold;
					wrq->u.data.length = sizeof(NDIS_802_11_RTS_THRESHOLD);
					copy_to_user(wrq->u.data.pointer, &ulInfo, wrq->u.data.length);
		            DBGPRINT(RT_DEBUG_TRACE, "INFO::RTLINUX_GET_OID_802_11_RTS_THRESHOLD(=%d)\n", ulInfo);
					break;

				case RTLINUX_SET_OID_802_11_RTS_THRESHOLD:
					if (wrq->u.data.length != sizeof(NDIS_802_11_RTS_THRESHOLD))
		                Status = -EINVAL;
		            else 
		            {
		            	copy_from_user(&RtsThresh, wrq->u.data.pointer, wrq->u.data.length);
						if (RtsThresh > MAX_RTS_THRESHOLD)
		                    Status = -EINVAL;
		                else 
		                    pAd->PortCfg.RtsThreshold = (USHORT)RtsThresh;
		            }
		            DBGPRINT(RT_DEBUG_TRACE, "INFO::RTLINUX_SET_OID_802_11_RTS_THRESHOLD (=%d)\n",RtsThresh);
		            break;

            	case RTLINUX_GET_OID_802_11_FRAGMENTATION_THRESHOLD:
            		ulInfo = pAd->PortCfg.FragmentThreshold;
		            if (pAd->PortCfg.bFragmentZeroDisable == TRUE)
		            	ulInfo = 0;
		            wrq->u.data.length = sizeof(NDIS_802_11_FRAGMENTATION_THRESHOLD);
					copy_to_user(wrq->u.data.pointer, &ulInfo, wrq->u.data.length);
		            DBGPRINT(RT_DEBUG_TRACE, "INFO::RTLINUX_GET_OID_802_11_FRAGMENTATION_THRESHOLD(=%d)\n", ulInfo);
		            break;

				case RTLINUX_SET_OID_802_11_FRAGMENTATION_THRESHOLD:
					if (wrq->u.data.length != sizeof(NDIS_802_11_FRAGMENTATION_THRESHOLD))
		                Status = -EINVAL;
		            else 
		            {
		            	copy_from_user(&FragThresh, wrq->u.data.pointer, wrq->u.data.length);
		                pAd->PortCfg.bFragmentZeroDisable = FALSE;
		                if (FragThresh > MAX_FRAG_THRESHOLD || FragThresh < MIN_FRAG_THRESHOLD)
		                	if (FragThresh == 0)
		                	{
		                		pAd->PortCfg.FragmentThreshold = MAX_FRAG_THRESHOLD;
		                		pAd->PortCfg.bFragmentZeroDisable = TRUE;
		                	}
		                	else
		                    	Status = -EINVAL;
		                else
		                    pAd->PortCfg.FragmentThreshold = (USHORT)FragThresh;
		            }
		            DBGPRINT(RT_DEBUG_TRACE, "INFO::RTLINUX_SET_OID_802_11_FRAGMENTATION_THRESHOLD (=%d) \n",FragThresh);
		            break;

				case RTLINUX_GET_OID_802_11_AUTHENTICATION_MODE:
        			wrq->u.data.length = sizeof(pAd->PortCfg.AuthMode);
        			copy_to_user(wrq->u.data.pointer, &pAd->PortCfg.AuthMode, wrq->u.data.length);

		            DBGPRINT(RT_DEBUG_TRACE, "INFO::RTLINUX_GET_OID_802_11_AUTHENTICATION_MODE(=%d)\n", ulInfo);
		            break;

				case RTLINUX_SET_OID_802_11_AUTHENTICATION_MODE:
					if (wrq->u.data.length != sizeof(NDIS_802_11_AUTHENTICATION_MODE)) 
		                Status = -EINVAL;
		            else 
		            {
		            	copy_from_user(&AuthMode, wrq->u.data.pointer, wrq->u.data.length);
        				if (AuthMode > Ndis802_11AuthModeMax)
        					Status = -EINVAL;
        				else
        					pAd->PortCfg.AuthMode = AuthMode;
		            }
        			pAd->PortCfg.PortSecured = WPA_802_1X_PORT_NOT_SECURED;
                    RTMPMakeRSNIE(pAd, pAd->PortCfg.AuthMode, pAd->PortCfg.WepStatus);
		            DBGPRINT(RT_DEBUG_TRACE, "INFO::RTLINUX_SET_OID_802_11_AUTHENTICATION_MODE (=%d) \n",AuthMode);
		            break;
		            
				case RTLINUX_GET_OID_802_11_WEP_STATUS:
        			ulInfo = pAd->PortCfg.WepStatus;
		            wrq->u.data.length = sizeof(NDIS_802_11_WEP_STATUS);
					copy_to_user(wrq->u.data.pointer, &ulInfo, wrq->u.data.length);
					
		            DBGPRINT(RT_DEBUG_TRACE, "INFO::RTLINUX_GET_OID_802_11_WEP_STATUS(=%d)\n", ulInfo);
		            break;

				case RTLINUX_SET_OID_802_11_WEP_STATUS:
					if (wrq->u.data.length != sizeof(NDIS_802_11_WEP_STATUS))
		                Status = -EINVAL;
		            else 
		            {
		            	copy_from_user(&WepStatus, wrq->u.data.pointer, wrq->u.data.length);
        				if (WepStatus <= Ndis802_11Encryption2KeyAbsent)
        				{
        					pAd->PortCfg.WepStatus = WepStatus;
        				}
		                else
		                    Status = -EINVAL;
		            }
		            DBGPRINT(RT_DEBUG_TRACE, "INFO::RTLINUX_SET_OID_802_11_WEP_STATUS (=%d)\n",WepStatus);
		            break;

				case RTLINUX_SET_OID_802_11_REMOVE_WEP:
					if (wrq->u.data.length != sizeof(NDIS_802_11_KEY_INDEX))
		                Status = -EINVAL;
		            else 
		            {
		            	copy_from_user(&KeyIdx, wrq->u.data.pointer, wrq->u.data.length);
						if (KeyIdx & 0x80000000)
						{
                			// Should never set default bit when remove key
							Status = -EINVAL;
						}
						else
		                {
		                	KeyIdx = KeyIdx & 0x0fffffff;
		                    if (KeyIdx > 4)
		                        Status = -EINVAL;
		                    else
		                        pAd->PortCfg.SharedKey[KeyIdx].KeyLen = 0;
		                }
		            }
		            DBGPRINT(RT_DEBUG_TRACE, "INFO::RTLINUX_SET_OID_802_11_REMOVE_WEP (id=%d)\n",KeyIdx);
		            break;

				case RTLINUX_SET_OID_802_11_ADD_WEP:
#if 0
					DBGPRINT(RT_DEBUG_TRACE, "INFO::RTLINUX_SET_OID_802_11_ADD_WEP\n");
					copy_from_user(&WepKey, wrq->u.data.pointer, wrq->u.data.length);
					KeyIdx = WepKey.KeyIndex & 0x0fffffff;
           			
					// it is a shared key
					if (KeyIdx > 4)
						Status = -EINVAL;
					else 
					{
						pAd->PortCfg.SharedKey[KeyIdx].KeyLen = (UCHAR) WepKey.KeyLength;
						NdisMoveMemory(pAd->PortCfg.SharedKey[KeyIdx].Key, &WepKey.KeyMaterial, WepKey.KeyLength);
            			if (WepKey.KeyIndex & 0x80000000)
           				{
             				// Default key for tx (shared key)
               				pAd->PortCfg.DefaultKeyId = (UCHAR) KeyIdx;
            			}
				   }
            
					DBGPRINT(RT_DEBUG_TRACE, "INFO::RTLINUX_SET_OID_802_11_ADD_WEP (id=%d, Len=%d-byte)\n", 
						KeyIdx, WepKey.KeyLength);
#endif
					break;

				case RTLINUX_SET_OID_802_11_CONFIGURATION:
					if (wrq->u.data.length != sizeof(NDIS_802_11_CONFIGURATION))
		                Status = -EINVAL;
		            else 
		            {
		            	copy_from_user(&Config, wrq->u.data.pointer, wrq->u.data.length);
		                pAd->PortCfg.BeaconPeriod = (USHORT) Config.BeaconPeriod;
		                pAd->PortCfg.AtimWin = (USHORT) Config.ATIMWindow;
		                if (Config.DSConfig == 2484000)
                			pAd->PortCfg.Channel = 14;
						else if (Config.DSConfig >= 2412000 && Config.DSConfig < 2484000) 
                			pAd->PortCfg.Channel = (UCHAR)((Config.DSConfig - 2412000) / 5000) + 1;
						else 
		                    Status = -EINVAL;
		            }
		            DBGPRINT(RT_DEBUG_TRACE, "INFO::RTLINUX_SET_OID_802_11_CONFIGURATION (BeacnPeriod=%d,AtimW=%d,Ch=%d)\n",
		                Config.BeaconPeriod, Config.ATIMWindow, pAd->PortCfg.Channel);
		            break;

				case RTLINUX_GET_OID_802_11_POWER_MODE:
					ulInfo = pAd->PortCfg.WindowsPowerMode;
					wrq->u.data.length = sizeof(NDIS_802_11_POWER_MODE);
					copy_to_user(wrq->u.data.pointer, &ulInfo, wrq->u.data.length);
		            DBGPRINT(RT_DEBUG_TRACE, "INFO::RTLINUX_GET_OID_802_11_POWER_MODE(=%d)\n", ulInfo);
		            break;

				case RTLINUX_SET_OID_802_11_POWER_MODE:
		            DBGPRINT(RT_DEBUG_TRACE, "INFO::RTLINUX_SET_OID_802_11_POWER_MODE\n");
		            break;

				case RTLINUX_SET_OID_802_11_SSID:
					if (wrq->u.data.length > MAX_LEN_OF_SSID + sizeof(ULONG))
			            Status = -EINVAL;
		            else 
		            {
		                copy_from_user(&Ssid, wrq->u.data.pointer, wrq->u.data.length);
		                
		    	        if(Ssid.SsidLength > 32)
				            Status = -EINVAL;
			            else 
			            {
		                    NdisMoveMemory(pAd->PortCfg.Ssid, Ssid.Ssid, Ssid.SsidLength);
	                		pAd->PortCfg.SsidLen = (UCHAR)Ssid.SsidLength;
			            }
		                DBGPRINT(RT_DEBUG_TRACE, "INFO::RTLINUX_SET_OID_802_11_SSID (Len=%d,Ssid=%s)\n", Ssid.SsidLength, Ssid.Ssid);
		                RestartAPIsRequired = TRUE;
			        }
			        break;

				case RTLINUX_GET_OID_802_11_STATISTICS:
					DBGPRINT(RT_DEBUG_TRACE, "INFO::RTLINUX_GET_OID_802_11_STATISTICS \n");
		            // Update FCS counters
		            RTMP_IO_READ32(pAd, CNT0, &FcsValue);
		            pAd->WlanCounters.FCSErrorCount += FcsValue;
		            
		            Statistics.TransmittedFragmentCount = pAd->WlanCounters.TransmittedFragmentCount;
		            Statistics.MulticastTransmittedFrameCount = pAd->WlanCounters.MulticastTransmittedFrameCount;
		            Statistics.FailedCount = pAd->WlanCounters.FailedCount;
		            Statistics.RetryCount = pAd->WlanCounters.RetryCount;
		            Statistics.MultipleRetryCount = pAd->WlanCounters.MultipleRetryCount;
		            Statistics.RTSSuccessCount = pAd->WlanCounters.RTSSuccessCount;
		            Statistics.RTSFailureCount = pAd->WlanCounters.RTSFailureCount;
		            Statistics.ACKFailureCount = pAd->WlanCounters.ACKFailureCount;
		            Statistics.FrameDuplicateCount = pAd->WlanCounters.FrameDuplicateCount;
		            Statistics.ReceivedFragmentCount = pAd->WlanCounters.ReceivedFragmentCount;
		            Statistics.MulticastReceivedFrameCount = pAd->WlanCounters.MulticastReceivedFrameCount;
		            Statistics.FCSErrorCount = pAd->WlanCounters.FCSErrorCount;
		            wrq->u.data.length = sizeof(NDIS_802_11_STATISTICS);
					copy_to_user(wrq->u.data.pointer, &Statistics, wrq->u.data.length);					
		            break;

				case RTLINUX_GET_OID_GEN_RCV_OK:
					DBGPRINT(RT_DEBUG_INFO, "INFO::RTLINUX_GET_OID_GEN_RCV_OK \n");
					ulInfo = pAd->Counters.GoodReceives;
					wrq->u.data.length = sizeof(ulInfo);
					copy_to_user(wrq->u.data.pointer, &ulInfo, wrq->u.data.length);
					break;

				case RTLINUX_GET_OID_GEN_RCV_NO_BUFFER:
					DBGPRINT(RT_DEBUG_INFO, "INFO::RTLINUX_GET_OID_GEN_RCV_NO_BUFFER \n");
					ulInfo = pAd->Counters.RxNoBuffer;
					wrq->u.data.length = sizeof(ulInfo);
					copy_to_user(wrq->u.data.pointer, &ulInfo, wrq->u.data.length);
					break;

				case RTLINUX_SET_RT_OID_802_11_RESET_COUNTERS:
					DBGPRINT(RT_DEBUG_TRACE, "INFO::RTLINUX_SET_RT_OID_802_11_RESET_COUNTERS!!!\n");
					memset(&pAd->WlanCounters, 0, sizeof(COUNTER_802_11));
        		    memset(&pAd->Counters, 0, sizeof(COUNTER_802_3));
    	        	memset(&pAd->RalinkCounters, 0 ,sizeof(COUNTER_RALINK));
		            memset(&pAd->Mlme.PrevWlanCounters, 0, sizeof(COUNTER_802_11));
					break;

				case RTLINUX_GET_OID_802_3_CURRENT_ADDRESS:
					DBGPRINT(RT_DEBUG_INFO, "INFO::RTLINUX_GET_OID_802_3_CURRENT_ADDRESS \n");
					wrq->u.data.length = ETH_LENGTH_OF_ADDRESS;
					copy_to_user(wrq->u.data.pointer, &pAd->CurrentAddress, wrq->u.data.length);
					break;

				case RTLINUX_GET_VERSION_INFO:
					DBGPRINT(RT_DEBUG_INFO, "INFO::RTLINUX_GET_VERSION_INFO \n");
					DriverVersionInfo.DriverMajorVersion = 1;
					DriverVersionInfo.DriverMinorVersion = 1;
					DriverVersionInfo.DriverSubVersion = 0;
					DriverVersionInfo.DriverBuildYear = 2004;
					DriverVersionInfo.DriverBuildMonth = 1;
					DriverVersionInfo.DriverBuildDay = 30;
					wrq->u.data.length = sizeof(RT_VERSION_INFO);
					copy_to_user(wrq->u.data.pointer, &DriverVersionInfo, wrq->u.data.length);
					break;

#if	RT2400_DBG
				case RTLINUX_GET_RT_OID_802_11_QUERY_HARDWARE_REGISTER:
		        	if (wrq->u.data.length != sizeof(RT_802_11_HARDWARE_REGISTER))
		                Status = -EINVAL;
		            else 
		            {
			        	copy_from_user(&HardwareRegister, wrq->u.data.pointer, sizeof(RT_802_11_HARDWARE_REGISTER));
		                if (HardwareRegister.HardwareType == 0)
		                {
		                    // MAC register read procedure
		                    RTMP_IO_READ32(pAd, HardwareRegister.Offset, &HardwareRegister.Data);
		                    wrq->u.data.length = sizeof(RT_802_11_HARDWARE_REGISTER);
							copy_to_user(wrq->u.data.pointer, &HardwareRegister, wrq->u.data.length);
		                }
		                else if (HardwareRegister.HardwareType == 1)
		                {
		                    // BBP register read procedure
		                    RTMP_BBP_IO_READ32_BY_REG_ID(pAd, HardwareRegister.Offset, &HardwareRegister.Data);
		                    wrq->u.data.length = sizeof(RT_802_11_HARDWARE_REGISTER);
		                    copy_to_user(wrq->u.data.pointer, &HardwareRegister, wrq->u.data.length);
		                }
		                else
		                {
			                wrq->u.data.length = 0;
		                    Status = -EINVAL;
		                }
		                DBGPRINT(RT_DEBUG_TRACE, "INFO::RT_OID_802_11_QUERY_HARDWARE_REGISTER (type=%d, offset=%d, data=%d)\n", HardwareRegister.HardwareType, HardwareRegister.Offset, HardwareRegister.Data);
		            }
		            break;

		        case RTLINUX_SET_RT_OID_802_11_SET_HARDWARE_REGISTER:
		        	if (wrq->u.data.length != sizeof(RT_802_11_HARDWARE_REGISTER))
		                Status = -EINVAL;
		            else 
		            {
		            	copy_from_user(&HardwareRegister, wrq->u.data.pointer, sizeof(RT_802_11_HARDWARE_REGISTER));
		                if (HardwareRegister.HardwareType == 0)
		                {
		                    // MAC register write procedure
		                    RTMP_IO_WRITE32(pAd, HardwareRegister.Offset, HardwareRegister.Data);
		                }
		                else if (HardwareRegister.HardwareType == 1)
		                {
		                    // BBP register write procedure
		                    RTMP_BBP_IO_WRITE32_BY_REG_ID(pAd, HardwareRegister.Offset, HardwareRegister.Data);
		                }
		                else if (HardwareRegister.HardwareType == 2)
		                {
		                    // RF register write procedure (haven't been verified, like bit order)
#if 0                    
		                    RfCsr.word = 0;
		                    RfCsr.field.Busy = 1;
		                    RfCsr.field.RFRegValue = pHardwareRegister->Data;
		                    RfCsr.field.NumberOfBits= 20;
		                    RfCsr.field.IFSelect= 0;
		                    RfCsr.field.PLL_LD= 0;
		                    RTMP_RF_IO_WRITE32(pAd, RfCsr.word);
#endif
		                    Status = -EOPNOTSUPP;
		                }
		                DBGPRINT(RT_DEBUG_TRACE, "INFO::RT_OID_802_11_QUERY_HARDWARE_REGISTER (type=%d, offset=%d, data=%d)\n", HardwareRegister.HardwareType, HardwareRegister.Offset, HardwareRegister.Data);
		            }
		        	break;
#endif
				case RTLINUX_RT_OID_802_11_SET_COUNTRY_REGION:
					DBGPRINT(RT_DEBUG_INFO, "INFO::RTLINUX_RT_OID_802_11_SET_COUNTRY_REGION \n");
					copy_from_user(&pAd->PortCfg.CountryRegion, wrq->u.data.pointer, wrq->u.data.length);
					break;

				case RTLINUX_GET_OID_802_11_QUERY_EVENT_TABLE:
		            if (wrq->u.data.length != sizeof(RT_802_11_EVENT_TABLE))
		                Status = -EINVAL;
		            else 
		            {
		                wrq->u.data.length = 8 + pAd->EventTab.Num * sizeof(RT_802_11_EVENT_LOG);
		            	copy_to_user(wrq->u.data.pointer, &pAd->EventTab, wrq->u.data.length);

		            	// pAd->EventTab is read-and-clear
			            NdisZeroMemory(&pAd->EventTab, sizeof(RT_802_11_EVENT_TABLE));

						DBGPRINT(RT_DEBUG_INFO, "INFO::RTLINUX_GET_OID_802_11_QUERY_EVENT_TABLE\n");
		            }
		            break;

	            case RTLINUX_GET_OID_802_11_QUERY_MAC_TABLE:
		            if (wrq->u.data.length != sizeof(RT_802_11_MAC_TABLE))
		                Status = -EINVAL;
		            else
		            {
		                MacTab.Num=0;
		                for (i=0; i<MAX_LEN_OF_MAC_TABLE; i++)
		                {
		                    if (pAd->MacTab.Content[i].Valid && (pAd->MacTab.Content[i].Sst == SST_ASSOC))
		                    {
		                        COPY_MAC_ADDR(MacTab.Entry[MacTab.Num].Addr, &pAd->MacTab.Content[i].Addr);
		                        MacTab.Entry[MacTab.Num].Aid = (UCHAR)pAd->MacTab.Content[i].Aid;
		                        MacTab.Entry[MacTab.Num].Psm = pAd->MacTab.Content[i].PsMode;
		                        MacTab.Num += 1;
		                    }
		                }
		                wrq->u.data.length = 4 + MacTab.Num * sizeof(RT_802_11_MAC_ENTRY);
		                copy_to_user(wrq->u.data.pointer, &MacTab, wrq->u.data.length);

						DBGPRINT(RT_DEBUG_INFO, "INFO::RTLINUX_GET_OID_802_11_QUERY_MAC_TABLE\n");
		            }
		            break;
					
			case RTLINUX_SET_OID_802_11_FILTER_ENTRY:
		            if (wrq->u.data.length != sizeof(RT_802_11_FILTER_ENTRY))
		                Status = -EINVAL;
		            else
		            {
		                copy_from_user(&pAd->FilterEntry, wrq->u.data.pointer, wrq->u.data.length);

				DBGPRINT(RT_DEBUG_INFO, "INFO::RTLINUX_SET_OID_802_11_FILTER_ENTRY(=%d)\n", pAd->FilterEntry.Mode);

				DBGPRINT(RT_DEBUG_TRACE, "0>> %02X:%02X:%02X:%02X:%02X:%02X\n", pAd->FilterEntry.Addr[0][0],pAd->FilterEntry.Addr[0][1],pAd->FilterEntry.Addr[0][2],pAd->FilterEntry.Addr[0][3],
													pAd->FilterEntry.Addr[0][4],pAd->FilterEntry.Addr[0][5]);
				DBGPRINT(RT_DEBUG_TRACE, "1>> %02X:%02X:%02X:%02X:%02X:%02X\n", pAd->FilterEntry.Addr[1][0],pAd->FilterEntry.Addr[1][1],pAd->FilterEntry.Addr[1][2],pAd->FilterEntry.Addr[1][3],
													pAd->FilterEntry.Addr[1][4],pAd->FilterEntry.Addr[1][5]);
				DBGPRINT(RT_DEBUG_TRACE, "2>> %02X:%02X:%02X:%02X:%02X:%02X\n", pAd->FilterEntry.Addr[2][0],pAd->FilterEntry.Addr[2][1],pAd->FilterEntry.Addr[2][2],pAd->FilterEntry.Addr[2][3],
													pAd->FilterEntry.Addr[2][4],pAd->FilterEntry.Addr[2][5]);
				DBGPRINT(RT_DEBUG_TRACE, "3>> %02X:%02X:%02X:%02X:%02X:%02X\n", pAd->FilterEntry.Addr[3][0],pAd->FilterEntry.Addr[3][1],pAd->FilterEntry.Addr[3][2],pAd->FilterEntry.Addr[3][3],
													pAd->FilterEntry.Addr[3][4],pAd->FilterEntry.Addr[3][5]);
				DBGPRINT(RT_DEBUG_TRACE, "4>> %02X:%02X:%02X:%02X:%02X:%02X\n", pAd->FilterEntry.Addr[4][0],pAd->FilterEntry.Addr[4][1],pAd->FilterEntry.Addr[4][2],pAd->FilterEntry.Addr[4][3],
													pAd->FilterEntry.Addr[4][4],pAd->FilterEntry.Addr[4][5]);
				DBGPRINT(RT_DEBUG_TRACE, "5>> %02X:%02X:%02X:%02X:%02X:%02X\n", pAd->FilterEntry.Addr[5][0],pAd->FilterEntry.Addr[5][1],pAd->FilterEntry.Addr[5][2],pAd->FilterEntry.Addr[5][3],
													pAd->FilterEntry.Addr[5][4],pAd->FilterEntry.Addr[5][5]);
		            }
		            break;
		            
			case RTLINUX_SET_OID_802_11_TEST_MODE:
		            if (wrq->u.data.length != sizeof(INT))
		                Status = -EINVAL;
		            else
		            {
		            	copy_from_user(&testmode, wrq->u.data.pointer, sizeof(INT));

		            	switch(testmode)
		            	{
		            		case 0:		// Disable test mode
		            			pAd->bContinuousRx = FALSE;
		            			pAd->bContinuousTx = FALSE;

						RTMP_IO_WRITE32(pAd, CSR18, 0x001e000a);
						RTMP_IO_WRITE32(pAd, RXCSR0, 0x56);
		            			netif_start_queue(pAd->net_dev);
		            			pAd->MediaState = NdisMediaStateConnected;
		            			NICEnableInterrupt(pAd);
		            			MlmeInit(pAd);
		            			pAd->PortCfg.Massoc = TRUE;
				            	RestartAPIsRequired = TRUE;
		            			break;

		            		case 1:		// Continuous Tx
		            			pAd->bContinuousRx = FALSE;
		            			pAd->bContinuousTx = TRUE;

		            			netif_stop_queue(pAd->net_dev);
						pAd->MediaState = NdisMediaStateDisconnected;
		            			ApStop(pAd);
		            			pAd->PortCfg.Massoc = FALSE;
				            	MlmeHalt(pAd);
				            	RTMP_IO_WRITE32(pAd, RXCSR0, 0x1);
				            	RTMP_IO_WRITE32(pAd, CSR8, 0xFFF7);		// only turn on TxDone Interrupt

				            	// set ifs as zero
				            	RTMP_IO_READ32(pAd, CSR18, &ifs);
				            	ifs &= 0xFFFF0000;
				            	RTMP_IO_WRITE32(pAd, CSR18, ifs);

				            	// Enqueue packet to transmit
				            	for (i = 0; i < TX_RING_SIZE; i++)
						{
							pTxD = (PTXD_STRUC)pAd->TxRing[i].va_addr;
							RTMPWriteTxDescriptor(pTxD, FALSE, FALSE, FALSE,
								SHORT_RETRY, IFS_SIFS, RATE_11, 4,
								1500, Rt802_11PreambleLong);
						}
				            	RTMP_IO_WRITE32(pAd, TXCSR0, 0x1);
				            	
		            			break;

		            		case 2:		// Continuous Rx
		            			pAd->bContinuousRx = TRUE;
		            			pAd->bContinuousTx = FALSE;

		            			RTMP_IO_WRITE32(pAd, RXCSR0, 0x56);
		            			netif_stop_queue(pAd->net_dev);
								pAd->MediaState = NdisMediaStateDisconnected;
		            			ApStop(pAd);
		            			pAd->PortCfg.Massoc = FALSE;
			            		MlmeHalt(pAd);
			            		RTMP_IO_WRITE32(pAd, CSR8, 0xFFBF);		// only turn on RxDone Interrupt
			            	
		            			break;

		            		default:
		            			break;
		            	}
		            	
		            	DBGPRINT(RT_DEBUG_TRACE, "INFO::RTLINUX_SET_OID_802_11_TEST_MODE(%d)\n", testmode);
		            }
		            break;
		            
			default:
				DBGPRINT(RT_DEBUG_TRACE, "INFO::unknown IOCTL's subcmd = 0x%08x\n", subcmd);
				Status = -EOPNOTSUPP;
				break;
			}
			break;		
			
		default:
			DBGPRINT(RT_DEBUG_TRACE, "INFO::unknown IOCTL's cmd = 0x%08x\n", cmd);
			Status = -EOPNOTSUPP;
			break;
	}

	if(Status == NDIS_STATUS_SUCCESS)
	{
		if((cmd == SIOCDEVPRIVATE) && (subcmd == RTLINUX_GET_OID_802_11_BSSID_LIST))
            kfree(pBssidList);
	}
	if (RestartAPIsRequired) 
    {
        ApStop(pAd);
        ApStartUp(pAd);
    }
	
	return Status;
}

/* 
    ==========================================================================
    Description:
        Set SSID
    Return:
        TRUE if all parameters are OK, FALSE otherwise
    ==========================================================================
*/
INT	Set_SSID_Proc(
	IN	PRTMP_ADAPTER	pAdapter, 
	IN	PUCHAR			arg)
{
	int   success = FALSE;

	if( strlen(arg) <= MAX_LEN_OF_SSID)
	{
		NdisZeroMemory(pAdapter->PortCfg.Ssid, MAX_LEN_OF_SSID);
		NdisMoveMemory(pAdapter->PortCfg.Ssid, arg, strlen(arg));
		pAdapter->PortCfg.SsidLen = (UCHAR)strlen(arg);
		success = TRUE;
		ApStop(pAdapter);
		ApStartUp(pAdapter);
		DBGPRINT(RT_DEBUG_TRACE, "Set_SSID_Proc::(Len=%d,Ssid=%s)\n", pAdapter->PortCfg.SsidLen, pAdapter->PortCfg.Ssid);
	}
	else
		success = FALSE;

	return success;
}
/* 
    ==========================================================================
    Description:
        Set Authentication mode
    Return:
        TRUE if all parameters are OK, FALSE otherwise
    ==========================================================================
*/
INT	Set_AuthMode_Proc(
	IN	PRTMP_ADAPTER	pAdapter, 
	IN	PUCHAR			arg)
{
	if ((strcmp(arg, "OPEN") == 0) || (strcmp(arg, "open") == 0))
		pAdapter->PortCfg.AuthMode = Ndis802_11AuthModeOpen;
	else if ((strcmp(arg, "SHARED") == 0) || (strcmp(arg, "shared") == 0))
		pAdapter->PortCfg.AuthMode = Ndis802_11AuthModeShared;
	else if ((strcmp(arg, "WPAPSK") == 0) || (strcmp(arg, "wpapsk") == 0))
		pAdapter->PortCfg.AuthMode = Ndis802_11AuthModeWPAPSK;
	else if ((strcmp(arg, "WPA") == 0) || (strcmp(arg, "wpa") == 0))
		pAdapter->PortCfg.AuthMode = Ndis802_11AuthModeWPA;
	else
		return FALSE;  

	pAdapter->PortCfg.PortSecured = WPA_802_1X_PORT_NOT_SECURED;
    RTMPMakeRSNIE(pAdapter, pAdapter->PortCfg.AuthMode, pAdapter->PortCfg.WepStatus);

	DBGPRINT(RT_DEBUG_TRACE, "Set_AuthMode_Proc::(AuthMode=%d)\n", pAdapter->PortCfg.AuthMode);

	return TRUE;
}
/* 
    ==========================================================================
    Description:
        Set Encryption Type
    Return:
        TRUE if all parameters are OK, FALSE otherwise
    ==========================================================================
*/
INT	Set_EncrypType_Proc(
	IN	PRTMP_ADAPTER	pAdapter, 
	IN	PUCHAR			arg)
{
	if ((strcmp(arg, "NONE") == 0) || (strcmp(arg, "none") == 0))
		pAdapter->PortCfg.WepStatus = Ndis802_11WEPDisabled;
	else if ((strcmp(arg, "WEP") == 0) || (strcmp(arg, "wep") == 0))
		pAdapter->PortCfg.WepStatus = Ndis802_11Encryption1Enabled;
	else if ((strcmp(arg, "TKIP") == 0) || (strcmp(arg, "tkip") == 0))
		pAdapter->PortCfg.WepStatus = Ndis802_11Encryption2Enabled;
	else
		return FALSE;

	DBGPRINT(RT_DEBUG_TRACE, "Set_EncrypType_Proc::(EncrypType=%d)\n", pAdapter->PortCfg.WepStatus);
    RTMPMakeRSNIE(pAdapter, pAdapter->PortCfg.AuthMode, pAdapter->PortCfg.WepStatus);

	return TRUE;
}
/* 
    ==========================================================================
    Description:
        Set Default Key ID
    Return:
        TRUE if all parameters are OK, FALSE otherwise
    ==========================================================================
*/
INT	Set_DefaultKeyID_Proc(
	IN	PRTMP_ADAPTER	pAdapter, 
	IN	PUCHAR			arg)
{
	ULONG KeyIdx;

	KeyIdx = simple_strtol(arg, 0, 10);
	if((KeyIdx >= 1 ) && (KeyIdx <= 4))
		pAdapter->PortCfg.DefaultKeyId = (UCHAR) (KeyIdx - 1 );
	else
		return FALSE;  //Invalid argument 
	
	DBGPRINT(RT_DEBUG_TRACE, "Set_DefaultKeyID_Proc::(DefaultKeyID=%d)\n", pAdapter->PortCfg.DefaultKeyId);

	return TRUE;
}
/* 
    ==========================================================================
    Description:
        Set WEP KEY1
    Return:
        TRUE if all parameters are OK, FALSE otherwise
    ==========================================================================
*/
INT	Set_Key1_Proc(
	IN	PRTMP_ADAPTER	pAdapter, 
	IN	PUCHAR			arg)
{
	int KeyLen;
	int i;

	KeyLen = strlen(arg);

	switch (KeyLen)
	{
		case 5: //wep 40 Ascii type
			pAdapter->PortCfg.SharedKey[0].KeyLen = KeyLen;
			memcpy(pAdapter->PortCfg.SharedKey[0].Key, arg, KeyLen);	
			DBGPRINT(RT_DEBUG_TRACE, "Set_Key1_Proc::(Key1=%s and type=%s)\n", arg, "Ascii");		
			break;
		case 10: //wep 40 Hex type
			for(i=0; i < KeyLen; i++)
			{
				if( !isxdigit(*(arg+i)) )
					return FALSE;  //Not Hex value;
			}
			pAdapter->PortCfg.SharedKey[0].KeyLen = KeyLen / 2 ;
			AtoH(arg, pAdapter->PortCfg.SharedKey[0].Key, KeyLen / 2);
			DBGPRINT(RT_DEBUG_TRACE, "Set_Key1_Proc::(Key1=%s and type=%s)\n", arg, "Hex");		
			break;
		case 13: //wep 104 Ascii type
			pAdapter->PortCfg.SharedKey[0].KeyLen = KeyLen;
			memcpy(pAdapter->PortCfg.SharedKey[0].Key, arg, KeyLen);	
			DBGPRINT(RT_DEBUG_TRACE, "Set_Key1_Proc::(Key1=%s and type=%s)\n", arg, "Ascii");		
			break;
		case 26: //wep 104 Hex type
			for(i=0; i < KeyLen; i++)
			{
				if( !isxdigit(*(arg+i)) )
					return FALSE;  //Not Hex value;
			}
			pAdapter->PortCfg.SharedKey[0].KeyLen = KeyLen / 2 ;
			AtoH(arg, pAdapter->PortCfg.SharedKey[0].Key, KeyLen / 2);
			DBGPRINT(RT_DEBUG_TRACE, "Set_Key1_Proc::(Key1=%s and type=%s)\n", arg, "Hex");		
			break;
		default: //Invalid argument 
			DBGPRINT(RT_DEBUG_TRACE, "Set_Key1_Proc::Invalid argument (=%s)\n", arg);		
			return FALSE;
	}

	return TRUE;
}
/* 
    ==========================================================================
    Description:
        Set WEP KEY2
    Return:
        TRUE if all parameters are OK, FALSE otherwise
    ==========================================================================
*/
INT	Set_Key2_Proc(
	IN	PRTMP_ADAPTER	pAdapter, 
	IN	PUCHAR			arg)
{
	int KeyLen;
	int i;

	KeyLen = strlen(arg);

	switch (KeyLen)
	{
		case 5: //wep 40 Ascii type
			pAdapter->PortCfg.SharedKey[1].KeyLen = KeyLen;
			memcpy(pAdapter->PortCfg.SharedKey[1].Key, arg, KeyLen);	
			DBGPRINT(RT_DEBUG_TRACE, "Set_Key2_Proc::(Key2=%s and type=%s)\n", arg, "Ascii");		
			break;
		case 10: //wep 40 Hex type
			for(i=0; i < KeyLen; i++)
			{
				if( !isxdigit(*(arg+i)) )
					return FALSE;  //Not Hex value;
			}
			pAdapter->PortCfg.SharedKey[1].KeyLen = KeyLen / 2 ;
			AtoH(arg, pAdapter->PortCfg.SharedKey[1].Key, KeyLen / 2);
			DBGPRINT(RT_DEBUG_TRACE, "Set_Key2_Proc::(Key2=%s and type=%s)\n", arg, "Hex");		
			break;
		case 13: //wep 104 Ascii type
			pAdapter->PortCfg.SharedKey[1].KeyLen = KeyLen;
			memcpy(pAdapter->PortCfg.SharedKey[1].Key, arg, KeyLen);	
			DBGPRINT(RT_DEBUG_TRACE, "Set_Key2_Proc::(Key2=%s and type=%s)\n", arg, "Ascii");		
			break;
		case 26: //wep 104 Hex type
			for(i=0; i < KeyLen; i++)
			{
				if( !isxdigit(*(arg+i)) )
					return FALSE;  //Not Hex value;
			}
			pAdapter->PortCfg.SharedKey[1].KeyLen = KeyLen / 2 ;
			AtoH(arg, pAdapter->PortCfg.SharedKey[1].Key, KeyLen / 2);
			DBGPRINT(RT_DEBUG_TRACE, "Set_Key2_Proc::(Key2=%s and type=%s)\n", arg, "Hex");		
			break;
		default: //Invalid argument 
			DBGPRINT(RT_DEBUG_TRACE, "Set_Key2_Proc::Invalid argument (=%s)\n", arg);		
			return FALSE;
	}

	return TRUE;
}
/* 
    ==========================================================================
    Description:
        Set WEP KEY3
    Return:
        TRUE if all parameters are OK, FALSE otherwise
    ==========================================================================
*/
INT	Set_Key3_Proc(
	IN	PRTMP_ADAPTER	pAdapter, 
	IN	PUCHAR			arg)
{
	int KeyLen;
	int i;

	KeyLen = strlen(arg);

	switch (KeyLen)
	{
		case 5: //wep 40 Ascii type
			pAdapter->PortCfg.SharedKey[2].KeyLen = KeyLen;
			memcpy(pAdapter->PortCfg.SharedKey[2].Key, arg, KeyLen);	
			DBGPRINT(RT_DEBUG_TRACE, "Set_Key3_Proc::(Key3=%s and type=%s)\n", arg, "Ascii");		
			break;
		case 10: //wep 40 Hex type
			for(i=0; i < KeyLen; i++)
			{
				if( !isxdigit(*(arg+i)) )
					return FALSE;  //Not Hex value;
			}
			pAdapter->PortCfg.SharedKey[2].KeyLen = KeyLen / 2 ;
			AtoH(arg, pAdapter->PortCfg.SharedKey[2].Key, KeyLen / 2);
			DBGPRINT(RT_DEBUG_TRACE, "Set_Key3_Proc::(Key3=%s and type=%s)\n", arg, "Hex");		
			break;
		case 13: //wep 104 Ascii type
			pAdapter->PortCfg.SharedKey[2].KeyLen = KeyLen;
			memcpy(pAdapter->PortCfg.SharedKey[2].Key, arg, KeyLen);	
			DBGPRINT(RT_DEBUG_TRACE, "Set_Key3_Proc::(Key3=%s and type=%s)\n", arg, "Ascii");		
			break;
		case 26: //wep 104 Hex type
			for(i=0; i < KeyLen; i++)
			{
				if( !isxdigit(*(arg+i)) )
					return FALSE;  //Not Hex value;
			}
			pAdapter->PortCfg.SharedKey[2].KeyLen = KeyLen / 2 ;
			AtoH(arg, pAdapter->PortCfg.SharedKey[2].Key, KeyLen / 2);
			DBGPRINT(RT_DEBUG_TRACE, "Set_Key3_Proc::(Key3=%s and type=%s)\n", arg, "Hex");		
			break;
		default: //Invalid argument 
			DBGPRINT(RT_DEBUG_TRACE, "Set_Key3_Proc::Invalid argument (=%s)\n", arg);		
			return FALSE;
	}

	return TRUE;
}
/* 
    ==========================================================================
    Description:
        Set WEP KEY4
    Return:
        TRUE if all parameters are OK, FALSE otherwise
    ==========================================================================
*/
INT	Set_Key4_Proc(
	IN	PRTMP_ADAPTER	pAdapter, 
	IN	PUCHAR			arg)
{
	int KeyLen;
	int i;

	KeyLen = strlen(arg);

	switch (KeyLen)
	{
		case 5: //wep 40 Ascii type
			pAdapter->PortCfg.SharedKey[3].KeyLen = KeyLen;
			memcpy(pAdapter->PortCfg.SharedKey[3].Key, arg, KeyLen);	
			DBGPRINT(RT_DEBUG_TRACE, "Set_Key4_Proc::(Key4=%s and type=%s)\n", arg, "Ascii");		
			break;
		case 10: //wep 40 Hex type
			for(i=0; i < KeyLen; i++)
			{
				if( !isxdigit(*(arg+i)) )
					return FALSE;  //Not Hex value;
			}
			pAdapter->PortCfg.SharedKey[3].KeyLen = KeyLen / 2 ;
			AtoH(arg, pAdapter->PortCfg.SharedKey[3].Key, KeyLen / 2);
			DBGPRINT(RT_DEBUG_TRACE, "Set_Key4_Proc::(Key4=%s and type=%s)\n", arg, "Hex");		
			break;
		case 13: //wep 104 Ascii type
			pAdapter->PortCfg.SharedKey[3].KeyLen = KeyLen;
			memcpy(pAdapter->PortCfg.SharedKey[3].Key, arg, KeyLen);	
			DBGPRINT(RT_DEBUG_TRACE, "Set_Key4_Proc::(Key4=%s and type=%s)\n", arg, "Ascii");		
			break;
		case 26: //wep 104 Hex type
			for(i=0; i < KeyLen; i++)
			{
				if( !isxdigit(*(arg+i)) )
					return FALSE;  //Not Hex value;
			}
			pAdapter->PortCfg.SharedKey[3].KeyLen = KeyLen / 2 ;
			AtoH(arg, pAdapter->PortCfg.SharedKey[3].Key, KeyLen / 2);
			DBGPRINT(RT_DEBUG_TRACE, "Set_Key4_Proc::(Key4=%s and type=%s)\n", arg, "Hex");		
			break;
		default: //Invalid argument 
			DBGPRINT(RT_DEBUG_TRACE, "Set_Key4_Proc::Invalid argument (=%s)\n", arg);		
			return FALSE;
	}

	return TRUE;
}
/* 
    ==========================================================================
    Description:
        Set WPA PSK key

    Arguments:
        pAdapter            Pointer to our adapter
        arg                 WPA pre-shared key string

    Return:
        TRUE if all parameters are OK, FALSE otherwise
    ==========================================================================
*/
INT	Set_WPAPSK_Proc(
	IN	PRTMP_ADAPTER	pAdapter, 
	IN	PUCHAR			arg)
{
	UCHAR								keyMaterial[80];
	int									i;

	DBGPRINT(RT_DEBUG_TRACE, "Set_WPAPSK_Proc::(WPAPSK=%s)\n", arg);

	if ((strlen(arg) < 8) || (strlen(arg) > 64))
	{
		DBGPRINT(RT_DEBUG_TRACE, "Set failed!!(WPAPSK=%s), WPAPSK key-string required 8 ~ 64 characters \n", arg);
		return FALSE;
	}

	PasswordHash((char *)arg, pAdapter->PortCfg.Ssid, pAdapter->PortCfg.SsidLen, keyMaterial);
    DBGPRINT(RT_DEBUG_TRACE, "PMK = %x %x %x %x %x %x %x \n",pAdapter->PortCfg.PMK[0]\
        ,pAdapter->PortCfg.PMK[1],pAdapter->PortCfg.PMK[2],pAdapter->PortCfg.PMK[3]\
        ,pAdapter->PortCfg.PMK[4],pAdapter->PortCfg.PMK[5],pAdapter->PortCfg.PMK[6]);

	NdisMoveMemory(pAdapter->PortCfg.PMK, keyMaterial, 32);

#ifdef RT2500_DBG
	printk("Set_WPAPSK_Proc WPAPSK Key => \n");
	for (i = 0; i < 32; i++)
	{
		printk("%02x:", pAdapter->PortCfg.PMK[i]);
		if ((i%16) == 15)
			printk("\n");
	}
	printk("\n");
#endif

	return TRUE;
}

INT	Set_RekeyType_Proc(
	IN	PRTMP_ADAPTER	pAd, 
	IN	PUCHAR			arg)
{
    if (pAd->PortCfg.AuthMode < Ndis802_11AuthModeWPA)
    {
        if(pAd->PortCfg.REKEYTimerRunning == TRUE)
        {
            del_timer_sync(&pAd->PortCfg.REKEYTimer);
            pAd->PortCfg.REKEYTimerRunning = FALSE;
        }
    	return TRUE;
    }
    
	if ((strcmp(arg, "TIME") == 0) || (strcmp(arg, "time") == 0))
		pAd->PortCfg.WPAREKEY.ReKeyMethod= TIME_REKEY;
	else if ((strcmp(arg, "PACKET") == 0) || (strcmp(arg, "packet") == 0))
		pAd->PortCfg.WPAREKEY.ReKeyMethod= PKT_REKEY;
	else if ((strcmp(arg, "NONE") == 0) || (strcmp(arg, "none") == 0))
		pAd->PortCfg.WPAREKEY.ReKeyInterval = 0;
	else
		return FALSE;
    if (( pAd->PortCfg.REKEYTimerRunning == FALSE ) && (pAd->PortCfg.WPAREKEY.ReKeyInterval != 0))
    {
        add_timer(&pAd->PortCfg.REKEYTimer);
        pAd->PortCfg.REKEYTimer.expires = jiffies + GUPDATE_EXEC_INTV;
        pAd->PortCfg.REKEYTimerRunning = TRUE;
        pAd->PortCfg.REKEYCOUNTER = 0;
    }
	DBGPRINT(RT_DEBUG_TRACE, "Set_RekeyType_Proc::(RekeyType=%d)\n", pAd->PortCfg.WPAREKEY.ReKeyMethod);

	return TRUE;

}
INT	Set_RekeyPeriod_Proc(
	IN	PRTMP_ADAPTER	pAd, 
	IN	PUCHAR			arg)
{
    ULONG period;
    
	period=simple_strtol(arg, 0, 10);
    if (period == 0)
    {
        del_timer_sync(&pAd->PortCfg.REKEYTimer);
    	pAd->PortCfg.REKEYTimerRunning = FALSE;

    }
    else if (period <= MAX_REKEY_INTER)
    {
        pAd->PortCfg.WPAREKEY.ReKeyInterval = period;
        if ( pAd->PortCfg.REKEYTimerRunning == FALSE)
        {
            add_timer(&pAd->PortCfg.REKEYTimer);
            pAd->PortCfg.REKEYTimer.expires = jiffies + GUPDATE_EXEC_INTV;
            pAd->PortCfg.REKEYTimerRunning = TRUE;
            pAd->PortCfg.REKEYCOUNTER = 0;
        }
        
    }
	else
		return FALSE;
    
	DBGPRINT(RT_DEBUG_TRACE, "Set_RekeyPeriod_Proc::(RekeyPeriod=%d)\n", period);
	return TRUE;

}
